function util_toDecimal(x) {
  var f = parseFloat(x);
  if (isNaN(f)) {
  return;
  }
  f = Math.round(x*100);
  return f;
}

function util_getgooglewebiste_by_country(countryCode='countryUS'){
    let google_website_country = {
        'countryUS':'https://www.google.com/', //美国
        'countryCA':'https://www.google.ca/', //加拿大
        'countryCD':'https://www.google.cd/', //民主刚果
        'countryCG':'https://www.google.cg/', //刚果
        'countryCH':'https://www.google.ch/', //瑞士
        'countryCI':'https://www.google.ci/', //Cote D’Ivoire
        'countryCK':'https://www.google.co.ck/', //库克
        'countryCL':'https://www.google.cl/', //智利
        'countryCO':'https://www.google.com.co/', //哥伦比
        'countryCR':'https://www.google.co.cr/', //哥斯达尼加
        'countryCU':'https://www.google.com.cu/', //古
        'countryCZ':'https://www.google.cz/', //捷克
        'countryDE':'https://www.google.de/', //德国
        'countryDJ':'https://www.google.dj/', //吉布提
        'countryDK':'https://www.google.dk/', //丹麦
        'countryDM':'https://www.google.dm/', //多米尼加联邦
        'countryDO':'https://www.google.com.do/', //多米尼加共和
        'countryEC':'https://www.google.com.ec/', //厄瓜多
        'countryEE':'https://www.google.ee/', //爱沙尼亚
        'countryEG':'https://www.google.com.eg/', //埃
        'countryES':'https://www.google.es/', //西班牙
        'countryET':'https://www.google.com.et/', //埃塞俄比
        'countryFJ':'https://www.google.com.fj/', //斐
        'countryFM':'https://www.google.fm/', //密克罗尼西亚
        'countryFR':'https://www.google.fr/', //法国
        'countryGE':'https://www.google.ge/', //格鲁吉亚
        'countryGI':'https://www.google.com.gi/', //Gibraltar
        'countryGL':'https://www.google.gl/', //格陵兰
        'countryGM':'https://www.google.gm/',//冈比亚
        'countryGP':'https://www.google.gp/', //爪德罗普岛
        'countryGR':'https://www.google.gr/', //希腊
        'countryGT':'https://www.google.com.gt/', //危地马
        'countryGY':'https://www.google.gy/', //圭亚那
        'countryHK':'https://www.google.com.hk/', //香港
        'countryHR':'https://www.google.hr/', //克罗地亚
        'countryHT':'https://www.google.ht/', //海地
        'countryHU':'https://www.google.hu/', //匈牙利
        'countryID':'https://www.google.co.id/', //印度尼西亚
        'countryIE':'https://www.google.ie/', //爱尔兰
        'countryIL':'https://www.google.co.il/', //以色列
        'countryIN':'https://www.google.co.in/', //印度
        'countryIS':'https://www.google.is/', //冰岛
        'countryIT':'https://www.google.it/', //意大利
        'countryJM':'https://www.google.je/', //泽西岛
        'countryJO':'https://www.google.jo/', //约旦
        'countryJP':'https://www.google.co.jp/', //日本
        'countryKE':'https://www.google.co.ke/', //肯尼亚
        'countryKH':'https://www.google.com.kh/', //柬埔
        'countryKI':'https://www.google.ki/', //基里巴斯
        'countryKG':'https://www.google.kg/', //吉尔吉斯斯坦
        'countryKR':'https://www.google.co.kr/', //韩国
        'countryKZ':'https://www.google.kz/', //哈萨克斯坦
        'countryLA':'https://www.google.la/', //老挝
        'countryLI':'https://www.google.li/', //列支敦士登
        'countryLK':'https://www.google.lk/', //斯里兰卡
        'countryLS':'https://www.google.co.ls/', //莱索托
        'countryLT':'https://www.google.lt/', //立陶宛
        'countryLU':'https://www.google.lu/', //卢森堡
        'countryLV':'https://www.google.lv/', //拉托维亚
        'countryLY':'https://www.google.com.ly/', //利比
        'countryMA':'https://www.google.co.ma/', //摩洛哥
        'countryMD':'https://www.google.md/', //摩尔多瓦
        'countryMN':'https://www.google.mn/', //蒙古
        'countryMS':'https://www.google.ms/', //蒙特塞拉特
        'countryMT':'https://www.google.com.mt/', //马耳
        'countryMU':'https://www.google.mu/', //毛里求斯
        'countryMV':'https://www.google.mv/', //马尔代夫
        'countryMW':'https://www.google.mw/', //马拉维
        'countryMX':'https://www.google.com.mx/', //墨西
        'countryNA':'https://www.google.com.na/', //纳米比
        'countryNF':'https://www.google.com.nf/', //诺夫克
        'countryNG':'https://www.google.com.ng/', //尼日尼
        'countryNI':'https://www.google.com.ni/', //尼加拉
        'countryNL':'https://www.google.nl/', //荷兰
        'countryNO':'https://www.google.no/', //挪威
        'countryNP':'https://www.google.com.np/', //尼泊
        'countryNR':'https://www.google.nr/', //瑙鲁
        'countryNU':'https://www.google.nu/', //纽埃岛
        'countryNZ':'https://www.google.co.nz/', //新西兰
        'countryOM':'https://www.google.com.om/', //阿
        'countryPA':'https://www.google.com.pa/', //巴拿
        'countryPE':'https://www.google.com.pe/', //秘
        'countryPH':'https://www.google.com.ph/', //菲律
        'countryPK':'https://www.google.com.pk/', //巴基斯
        'countryPL':'https://www.google.pl/',//波兰
        'countryPN':'https://www.google.pn/', //皮特克恩岛
        'countryPR':'https://www.google.com.pr/',//波多黎
        'countryPT':'https://www.google.pt/', //葡萄牙
        'countryPY':'https://www.google.com.py/', //巴拉
        'countryQA':'https://www.google.com.qa/', //卡塔
        'countryRO':'https://www.google.ro/', //罗马尼亚
        'countryRU':'https://www.google.ru/', //俄罗斯
        'countryRW':'https://www.google.rw/', //卢旺达
        'countrySA':'https://www.google.com.sa/', //沙,
        'countrySB':'https://www.google.com.sb/', //所罗
        'countrySC':'https://www.google.sc/', //塞舌尔
        'countrySE':'https://www.google.se/', //瑞典
        'countrySG':'https://www.google.com.sg/', //新加
        'countrySH':'https://www.google.sh/', //圣赫勒拿岛
        'countrySI':'https://www.google.si/', //斯洛文尼亚
        'countrySK':'https://www.google.sk/', //斯洛伐克
        'countrySN':'https://www.google.sn/', //塞内加尔
        'countrySM':'https://www.google.sm/', //圣马力诺
        'countryST':'https://www.google.st/', //圣多美和普林西比
        'countrySV':'https://www.google.com.sv/', //萨尔瓦
        'countryTH':'https://www.google.co.th/', //泰国
        'countryTJ':'https://www.google.com.tj/', //塔吉克斯
        'countryTK':'https://www.google.tk/', //托克劳
        'countryTM':'https://www.google.tm/', //土库曼
        'countryTO':'https://www.google.to/', //汤加
        'countryTR':'https://www.google.com.tr/', //土耳
        'countryTT':'https://www.google.tt/', //特立尼和多巴哥
        'countryTW':'https://www.google.com.tw/', //台
        'countryUA':'https://www.google.com.ua/', //乌克
        'countryUG':'https://www.google.co.ug/', //乌干达
        'countryGB':'https://www.google.co.uk/', //英国
        'countryUY':'https://www.google.com.uy/', //乌拉
        'countryUZ':'https://www.google.co.uz/', //Uzbekistan
        'countryVC':'https://www.google.com.vc/', //圣文森特和格林纳丁
        'countryVE':'https://www.google.co.ve/', //委内瑞拉
        'countryVG':'https://www.google.vg/', //维京岛
        'countryVI':'https://www.google.co.vi/', //维尔京群岛
        'countryVN':'https://www.google.com.vn/', //越南
        'countryVU':'https://www.google.vu/', //瓦努尔图
        'countryWS':'https://www.google.ws/', //西萨摩亚
        'countryZA':'https://www.google.co.za/', //南非
        'countryZM':'https://www.google.co.zm/', //赞比亚
        'countryZW':'https://www.google.co.zw/', //津巴布韦
    };
    if(google_website_country.hasOwnProperty(countryCode)){
        return google_website_country[countryCode];
    }else{
        return 'https://www.google.com/';
    }
}

function domains_process(){
    //$('#message-info').html('加载中...');
    var bg = chrome.extension.getBackgroundPage();
    //
    bg.domains_get_data_process();
    //
    bg.domains_get(function (callback_data) {
        //$('#message-info').html('');
        //
        domains = callback_data['domains'];
        if(typeof domains === 'undefined' ){
            domains = [];
        }
        //
        if(domains.length ==0){
            //$('#message-info').html('');
            $('.batchdig-form').show();
        }
        //
        var domains_total = domains.length;
        var domains_hasdig = 0;
        var domains_hasdig_emails = 0;
        for(i=0;i<domains.length;i++){
            if(domains[i]['s'] == 2){
                domains_hasdig +=1;
            }
            var _emails = domains[i]['e'];
            domains_hasdig_emails += _emails.length;
        }
        if(domains_total>0){
            var domains_percentage = util_toDecimal(domains_hasdig/domains_total)+'%';
        }else{
            var domains_percentage = '0.00%';
        }
        //
        if(domains_total>0){
            var batchdig_desc = "正在挖掘<span>"+domains_total+"</span>个域名，已挖掘<span>"+domains_hasdig+"</span>个域名，已挖掘<span>"+domains_hasdig_emails+"</span>个邮箱，进度<span>"+domains_percentage+"</span>";
            $('#batchdig-desc').html(batchdig_desc);
            $('.actions').show();
        }else{
            $('#batchdig-desc').html('');
            $('.actions').hide();
        }

        //
        if(domains.length > 0){
            //
            var batchdig_list_wrapper_html = $('.batchdig-list-wrapper').html();
            if(batchdig_list_wrapper_html.length>0 && domains_hasdig==domains_total && domains_total>100){

            }else{
                //
                $('.batchdig-list-wrapper').html('');
                //
                for(i=0;i<domains.length;i++){
                    var _domain = domains[i];
                    var bl_item_html = "<div class='bl-item'>";
                    bl_item_html += "<div class='bl-item-domain'>"+_domain['d']+"</div>";
                    bl_item_html +="<div class='bl-item-emails'>";
                    var _emails = _domain['e'];
                    for(e=0;e<_emails.length;e++){
                        bl_item_html+="<div className='bl-item-email'>"+_emails[e]+"</div>";
                    }
                    bl_item_html +="</div>";
                    bl_item_html += "</div>";
                    //
                    $('.batchdig-list-wrapper').append(bl_item_html);
                    //
                }
            }
            //
        }else{
             $('.batchdig-list-wrapper').html('');
        }
        //如果长时间未动，就主动触发
        /*if(domains.length > 0 && domains_hasdig < domains_total){
            var last_t = 0;
            for(i=0;i<domains.length;i++){
                if(domains[i]['t'] > last_t){
                    last_t = domains[i]['t'];
                }
            }
            if((last_t+10) < Date.now()){
                for(i=0;i<domains.length;i++){
                    if(domains[i]['s']==0 || (domains[i]['s']==1 && domains[i]['q']==0)){
                        domains[i]['m'] = Date.now();
                        break;
                    }
                }
                for(i=0;i<domains.length;i++){
                    if(domains[i]['s'] == 1){
                        domains[i]['s'] = 0;
                    }
                }
                //
                bg.domains_set(domains);
                //
            }
        }*/
        //
    });
}
domains_process();

setInterval(domains_process, 10000);

$('#test_clean_data_btn').click(function (){
    var bg = chrome.extension.getBackgroundPage();
    //bg.domains_remove();
    bg.domains_clear();
    bg.domains_set_callback([],function (){
        //
        console.log('domain has clean');
        domains_process();
        //
    });
    //
});

$('#test_get_data_btn').click(function (){
    console.log('test_get_data_btn');
     var bg = chrome.extension.getBackgroundPage();
     bg.domains_get_data_process();
     console.log(fff);
});

$('#btn_domains_clean').click(function (){
    if(confirm("确定清空吗？") == true){
        var bg = chrome.extension.getBackgroundPage();
        //bg.domains_clear();
        bg.domains_remove();
    }
});
//
$('.batchdig-form form #submit').click(function (){
    var bg = chrome.extension.getBackgroundPage();
    bg.plugin_get_expire(function (callback_data){
        let expire_date = callback_data['expire'];
        if(typeof expire_date === 'undefined'){
            console.log('expire date undefined');
            console.log(typeof IS_TIEPAI);
            $('.jihuo').show();
            $('#expire_date').html("<span style='color:red;'>已过期或未激活</span>");
            if(IS_TIEPAI){
                $('#message-account-info').html("<span style='color:red;'>已过期或未激活，联系客服！</span>");
            }else{
                $('#message-account-info').html("<span style='color:red;'>已过期或未激活，</span><a href='https://www.gycharm.com/user/order-plugin' target='_blank'>续费或者购买后，</a> <span style='color:red;'>在下面输入框激活！</span>");
            }
            return;
        }else{
            expire_date = expire_date.replace('T00:00:00.000Z','');
            $('#expire_date').html(expire_date);
            if (util_check_expire(expire_date)) {
                $('.jihuo').show();
                $('#expire_date').html("<span style='color:red;'>已过期或未激活</span>");
                if(IS_TIEPAI) {
                    $('#message-account-info').html("<span style='color:red;'>已过期或未激活，联系客服！</span>");
                }else{
                    $('#message-account-info').html("<span style='color:red;'>已过期或未激活，</span><a href='https://www.gycharm.com/user/order-plugin' target='_blank'>续费或者购买后，</a> <span style='color:red;'>在下面输入框激活！</span>");
                }
                return;
            }
        }
        //
        var form_domains_value = $('#domains').val();
        //
        form_domains_value = form_domains_value.trim();
        //分割
        form_domains_arr = form_domains_value.split(/[(\r\n)\r\n]+/);
        //去重
        if(form_domains_arr.length>1){
            form_domains_arr = Array.from(new Set(form_domains_arr));
        }
        //检测是否含有http,如果未含有提示
        var not_hefa_url = [];
        var new_form_domains_arr = [];
        for(i=0;i<form_domains_arr.length;i++){
            var domain = form_domains_arr[i];
            //两边去空,小写
            domain = domain.trim().toLowerCase();
            //尽量让域名正确
            //https://www.emailcamel.com/ff/d/dd
            var _domain = domain.replace('//','');
            var _pos = _domain.indexOf('/');
            if(_pos!=-1){
                var _domain_yichu = _domain.slice(_pos);
                if(_domain_yichu!='/'){
                    domain = domain.replace(_domain_yichu, '');
                }
            }
            //
            form_domains_arr[i] = domain;
            //
            if(domain && domain.indexOf('http')==-1){
                not_hefa_url.push(domain);
            }else{
                if(domain){
                    new_form_domains_arr.push(domain);
                }
            }
        }
        //
        if(not_hefa_url.length>0){
            var message_info_waring = "<div style='color:red;max-height: 100px;overflow-y: scroll;'><p style='margin-bottom: 5px;'>以下网址缺少http或者https开头,请补充完整!</p>"+not_hefa_url.join('<br />')+"</div>";
            $('#message-info').html(message_info_waring);
        }else{
             //
            new_form_domains_arr = Array.from(new Set(new_form_domains_arr));
            form_domains_arr = new_form_domains_arr;
            if(form_domains_arr.length>0){
                console.log('form_domains_arr');
                console.log(form_domains_arr);
                var bg = chrome.extension.getBackgroundPage();
                //
                var domains = [];
                for(f=0;f<form_domains_arr.length;f++){
                    var domain = {
                        'd':form_domains_arr[f], //域名
                        'e':[], //邮箱列表
                        's':0,  //状态
                        'q':0,  //当前已请求量
                        'tq':0, //总请求量
                        't':0,  //当前请求完成时间戳
                        'm':0,   //长时间未动,popup->background主动更新
                    }
                    domains.push(domain);
                }
                bg.domains_set(domains);
                //
                $('#message-info').html('<div class="alert-info">添加成功</div>');
                $('.batchdig-form').hide();
                $('#domains').val('');
                domains_process();
                //
            }else{
                var message_info_waring = "<div style='color:red;'><p style='margin-bottom: 5px;'>请至少输入1个网址!</p></div>";
                $('#message-info').html(message_info_waring);
            }
        }
        //
    });
});
//

function util_check_expire(expire_date=''){
    if(expire_date==''){
        return true;
    }
    expire_date = expire_date.replace('T00:00:00.000Z','');
    let now_date = new Date();
    expire_date_list = expire_date.split('-');
    expire_date_f = new Date(expire_date_list[0], (expire_date_list[1]-1), expire_date_list[2]);
    if (now_date > expire_date_f) {
        return true;
    }
    return false;
}

function get_expire(){
    // popup ---> content
                      /*  chrome.tabs.query({
                            active: true,
                            currentWindow: true
                        }, (tabs) => {
                            let message = {
                                action: 'set_expire',
                                date: ''
                            }
                            chrome.tabs.sendMessage(tabs[0].id, message, res => {
                                console.log('popup=>content set_expire')
                                console.log(res)
                                expire_data = res[0];
                                expire_date = expire_data['expire'];
                                expire_date = expire_date.replace('T00:00:00.000Z','');
                                $('#expire_date').html(expire_date);
                                //$('.catalog-products-num').html('0');
                                //$('#message-info').html('');
                                //
                                //$('#message-info').html('完成,提取:'+res.length);
                                //$('#message-info').html('完成')
                            })
                        })*/
    var bg = chrome.extension.getBackgroundPage();
    bg.plugin_get_expire(function (callback_data){
        let expire_date = callback_data['expire'];
        if(typeof expire_date === 'undefined'){
            $('.jihuo').show();
            $('#expire_date').html("<span style='color:red;'>已过期或未激活</span>");
            if(IS_TIEPAI) {
                $('#message-account-info').html("<span style='color:red;'>已过期或未激活，联系客服！</span>");
            }else{
                $('#message-account-info').html("<span style='color:red;'>已过期或未激活，</span><a href='https://www.gycharm.com/user/order-plugin' target='_blank'>续费或者购买后，</a> <span style='color:red;'>在下面输入框激活！</span>");
            }
            return;
        }else{
            expire_date = expire_date.replace('T00:00:00.000Z','');
            $('#expire_date').html(expire_date);
            if (util_check_expire(expire_date)) {
                $('.jihuo').show();
                $('#expire_date').html("<span style='color:red;'>已过期或未激活</span>");
                if(IS_TIEPAI) {
                    $('#message-account-info').html("<span style='color:red;'>已过期或未激活，联系客服！</span>");
                }else{
                    $('#message-account-info').html("<span style='color:red;'>已过期或未激活，</span><a href='https://www.gycharm.com/user/order-plugin' target='_blank'>续费或者购买后，</a> <span style='color:red;'>在下面输入框激活！</span>");
                }
                return;
            }
        }
    });
}

get_expire();

function extract_domains_export_clean(){
    $('#btn_domains_export').click(function (){
        //
        $('#message-info').html('<span style="font-size: 12px;">导出需要花费时间，请保持界面不动,处理中...</span>');
        console.log('extract_domains_export_clean');
        //
        var bg = chrome.extension.getBackgroundPage();
        bg.domains_get(function (callback_data) {
            //
            domains = callback_data['domains'];
            if (typeof domains === 'undefined') {
                domains = [];
            }
            //
            var export_domains = [];
            for(i=0;i<domains.length;i++){
                var _emails = domains[i]['e'];
                for(j=0;j<_emails.length;j++){
                    //
                    let _email = _emails[j];
                    let _phone = '';
                    let _whatsapp = '';
                    if(_email.indexOf('tel')!=-1){
                        _phone = _email.replace('tel:','');
                        _email = '';
                    }
                    if(_email.indexOf('whatsapp')!=-1){
                        _whatsapp = _email.replace('whatsapp:','');
                        _email = '';
                    }
                    //
                    export_domains.push({
                        'domain': domains[i]['d'],
                        'email': _email,
                        'phone':_phone,
                        'whatsapp':_whatsapp
                    })
                }
            }
            //
            /*$("#dvjson").excelexportjs({
                    containerid: "dvjson"
                       , datatype: 'json'
                       , dataset: export_domains
                       , columns: getColumns(export_domains)
                       , filename: 'gycharm-domains-emails-'+Date.now()
            });*/
            //
            exportToExcel(export_domains, 'data-domains-emails-export-'+Date.now(), "Sheet1");
            //
            //
            $('#message-info').html('');
        });
        //
    });
}

extract_domains_export_clean();

//
function jihuo(){
    $('#jihuo_btn').click(function (){
        var jihuo_text = $('#jihuo_text').val();
        jihuo_text = jihuo_text.trim();
        $('#message-account-info').html('');
        if(jihuo_text==''){
            $('#message-account-info').html('<span style="color:red;">请输入激活码</span>');
            return;
        }
        //
        // other then GET
        let options = {
            method: 'GET',
            headers: {
                'Content-Type':'application/json;charset=utf-8'
            },
            //body: JSON.stringify(res)
        }
        // Fake api for making post requests
        let fetchRes = fetch( "https://api.gycharm.com/v1/plugin-chkpro/" + jihuo_text);
        fetchRes.then(res =>
            res.json()).then(d => {
                console.log('post response:');
                console.log(d);
                console.log(d['VAL']);
                //
                if (d['VAL'] === "NO_KEY") {
                    $('#message-account-info').html('<span style="color:red;">激活码不存在!</span>');
                }else if(d['VAL'] == 'HAS_BOUND'){
                    $('#message-account-info').html('<span style="color:red;">激活码已使用过!</span>');
                }else {
                    var expire_date = d['VAL'];
                    if (util_check_expire(expire_date) == false) {
                        var bg = chrome.extension.getBackgroundPage();
                        bg.plugin_set_expire(expire_date,function (){
                            expire_date = expire_date.replace('T00:00:00.000Z','');
                            $('#expire_date').html(expire_date);
                            $('.jihuo').hide();
                            $('#message-account-info').html('');
                        });
                      //
                    }else{
                        $('.jihuo').show();
                        $('#expire_date').html("<span style='color:red;'>已过期或未激活</span>");
                        if(IS_TIEPAI) {
                            $('#message-account-info').html("<span style='color:red;'>已过期或未激活，联系客服！</span>");
                        }else{
                            $('#message-account-info').html("<span style='color:red;'>已过期或未激活，</span><a href='https://www.gycharm.com/user/order-plugin' target='_blank'>续费或者购买后，</a> <span style='color:red;'>在下面输入框激活！</span>");
                        }
                        return;
                    }
                }
                //
            })
                //
    });
}
jihuo();
//
//get columns
function getColumns(paramData){

	var header = [];
	$.each(paramData[0], function (key, value) {
		//console.log(key + '==' + value);
		var obj = {}
		obj["headertext"] = key;
		obj["datatype"] = "string";
		obj["datafield"] = key;
		header.push(obj);
	});
	return header;
}
///////////////
//
function data_process(){
    //$('#message-info').html('加载中...');
    var bg = chrome.extension.getBackgroundPage();
    //
    bg.get_data_process();
    //
    bg.data_process_get(function (callback_data) {
        //$('#message-info').html('');
        let data_process = callback_data['data_process'];
        let total_add_shangjia_num = 0;
        let has_caiji_geren_num = 0;
        let has_caiji_company_num = 0;
        if(typeof data_process !== 'undefined' ){
            total_add_shangjia_num = data_process['total_add_shangjia_num'];
            has_caiji_geren_num = data_process['has_caiji_geren_num'];
            has_caiji_company_num = data_process['has_caiji_company_num'];
            //
            $('#data_process').html("批量搜：已添加<span>"+total_add_shangjia_num+"</span>个关键词,已采集<span>"+has_caiji_geren_num+"</span>个");
            //
            if(total_add_shangjia_num > 0){
                bg.storage_get(function (inner_callback_data) {
                //
                if(inner_callback_data['pause'] == 1){
                    $('#extract-catalog-products-pause').text('采集已暂停,可点击开启');
                }else{
                    $('#extract-catalog-products-pause').text('采集已开启,可点击暂停');
                }
                });
                $('#extract-catalog-products-pause').show();
            }
            //
        }
        //
    });
}
data_process();

setInterval(data_process, 3000);
//

function extract_catalog_products_pause(){
    $('#extract-catalog-products-pause').click(function (){
        //
        var bg = chrome.extension.getBackgroundPage();
        bg.pause_switch(function (){
            bg.storage_get(function (callback_data) {
                //
                if(callback_data['pause'] == 1){
                    $('#extract-catalog-products-pause').text('采集已暂停,可点击开启');
                }else{
                    $('#extract-catalog-products-pause').text('采集已开启,可点击暂停');
                }
            });
          //
        });
        //
    });
}
extract_catalog_products_pause();
//
function extract_catalog_products_clean(){
    $('#extract-catalog-products-clean').click(function (){
        if(confirm("确认清空吗?")) {
            var bg = chrome.extension.getBackgroundPage();
            bg.storage_clear();
            //
        }
    });
}

extract_catalog_products_clean();
//
function extract_catalog_products_export_clean(){
    $('#extract-catalog-products-export-clean').click(function (){
         //
        $('#message-info').html('<span style="font-size: 12px;">提取需要花费时间，请保持界面不动,处理中...</span>')
        console.log('extract-catalog-products-url');
        //
        var bg = chrome.extension.getBackgroundPage();
        bg.storage_get(function (callback_data) {
            console.log('extract_catalog_products_export_clean');
            console.log(callback_data);
            //
            let expire_date = callback_data['expire'];
            if(typeof expire_date === 'undefined'){
                $('.jihuo').show();
                $('#expire_date').html("<span style='color:red;'>已过期或未激活</span>");
                if(IS_TIEPAI) {
                    $('#message-account-info').html("<span style='color:red;'>已过期或未激活，联系客服！</span>");
                }else{
                    $('#message-account-info').html("<span style='color:red;'>已过期或未激活，</span><a href='https://www.gycharm.com/user/order-plugin' target='_blank'>续费或者购买后，</a> <span style='color:red;'>在下面输入框激活！</span>");
                }
                return;
            }else{
                console.log('expire_date');
                console.log(expire_date);
                expire_date = expire_date.replace('T00:00:00.000Z','');
                $('#expire_date').html(expire_date);
                if (util_check_expire(expire_date)) {
                    $('.jihuo').show();
                    $('#expire_date').html("<span style='color:red;'>已过期或未激活</span>");
                    if(IS_TIEPAI) {
                        $('#message-account-info').html("<span style='color:red;'>已过期或未激活，联系客服！</span>");
                    }else{
                        $('#message-account-info').html("<span style='color:red;'>已过期或未激活，</span><a href='https://www.gycharm.com/user/order-plugin' target='_blank'>续费或者购买后，</a> <span style='color:red;'>在下面输入框激活！</span>");
                    }
                    return;
                }
            }
            //
            let shangjias = callback_data['shangjias'];
            let export_datas = [];
            //
            for(let i=0;i<shangjias.length;i++){
                //
                let profile_id = shangjias[i];
                let shangjia_about_contact_and_basic_info_storage_key = 'shangjia_about_contact_and_basic_info_'+$.md5(profile_id);
                if(callback_data.hasOwnProperty(shangjia_about_contact_and_basic_info_storage_key)){
                    let shangjia_about_contact_and_basic_info = callback_data[shangjia_about_contact_and_basic_info_storage_key];
                    let is_request = '未请求';
                    if(shangjia_about_contact_and_basic_info['_is_request']==2){
                        is_request = '已请求';
                    }else if(shangjia_about_contact_and_basic_info['_error']){
                        is_request = '有请求';
                    }
                    export_datas.push({
                        'search keyword': shangjia_about_contact_and_basic_info['_shangjia_name'],
                        'search url': shangjia_about_contact_and_basic_info['_shangjia_about_contact_and_basic_info_link'],
                        'url':'',
                        'website':'',
                        'domain':'',
                        'title':'',
                        'description':'',
                        'is_request':is_request,
                        'error':shangjia_about_contact_and_basic_info['_error']
                    });
                    let _search_result = shangjia_about_contact_and_basic_info['_search_result'];
                    for(let si = 0; si< _search_result.length; si++){
                        let _search_result_item = _search_result[si];
                        if(_search_result_item['url'] && _search_result_item['url'].indexOf('http')!=-1){
                             let export_data_item = {
                                'search keyword':'',
                                'search url':'',
                                'url':_search_result_item['url'],
                                'website':_search_result_item['website'],
                                'domain':_search_result_item['domain'],
                                'title':_search_result_item['title'],
                                'description':_search_result_item['description'],
                                'is_request':'',
                                'error':''
                            }
                            export_datas.push(export_data_item);
                        }
                    }
                }
            }
            //
            exportToExcel(export_datas, 'data-find-batch-export-'+Date.now(), "Sheet1");
            //
            //
            $('#message-info').html('');
            //
        });
        //
    });
}

extract_catalog_products_export_clean();
//
function google_search_batch(){
    console.log('google_search_batch');
    console.log('a3');
    $('.form-google #form_google_batch_submit').click(function (){
        let as_q_val  = $('.form-google #as_q').val(); //关键词
        as_q_val = as_q_val.trim();
        //
        as_q_val = as_q_val.trim();
        //分割
        as_q_val_arr = as_q_val.split(/[(\r\n)\r\n]+/);
        //去重
        if(as_q_val_arr.length>1){
            as_q_val_arr = Array.from(new Set(as_q_val_arr));
        }
        //
        let as_epq_val = $('.form-google #as_epq').val(); //完全匹配词
        as_epq_val = as_epq_val.trim();
        let as_oq_val  = $('.form-google #as_oq').val(); //任意词
        as_oq_val = as_oq_val.trim();
        let as_eq_val = $('.form-google #as_eq').val(); //排除词
        as_eq_val = as_eq_val.trim();
        let cr_val = $('.form-google #cr').val(); //国家
        let lr_val = $('.form-google #lr').val(); //语言
        let as_nlo_val = $('.form-google #as_nlo').val(); //开始年份
        as_nlo_val = as_nlo_val.trim();
        let as_nhi_val = $('.form-google #as_nhi').val(); //结束年份
        as_nhi_val = as_nhi_val.trim();

        if(as_q_val==''){
            alert("关键词不能为空！");
            return false;
        }
        //
        var shangjia_infos = [];
        //
        for(let i=0;i<as_q_val_arr.length;i++){
            let google_search_url = util_getgooglewebiste_by_country(cr_val)+'search?';

            let q = as_q_val_arr[i];

            if(as_oq_val!=''){
                let as_oq_val_list = as_oq_val.split(' ');
                let as_oq_val_list_new = [];
                for(let i=0;i<as_oq_val_list.length;i++){
                    let as_oq_val_temp = as_oq_val_list[i];
                    as_oq_val_temp = as_oq_val_temp.trim();
                    as_oq_val_list_new.push(as_oq_val_temp);
                }
                //
                q += '+';
                q += as_oq_val_list_new.join('+OR+')
                //
            }

            if(as_epq_val!=''){
                q += "+" + '"' + as_epq_val + '"'
            }

            if(as_eq_val!=''){
                let as_eq_val_list = as_eq_val.split(/[(\r\n)\r\n]+/);
                if(as_eq_val_list.length>0){
                    let as_eq_val_list_new = [];
                    for(let i=0;i<as_eq_val_list.length;i++){
                        let as_eq_val_temp = as_eq_val_list[i];
                        as_eq_val_temp = as_eq_val_temp.trim();
                        as_eq_val_list_new.push(as_eq_val_temp);
                    }
                    q += '+-';
                    q += as_eq_val_list_new.join("+-");
                }
            }
            google_search_url += 'q=' + q;
            if(as_nlo_val!=''){
                google_search_url += '&as_nlo='+as_nlo_val;
            }
            if(as_nhi_val!=''){
                google_search_url += '&as_nhi='+as_nhi_val;
            }
            if(cr_val!=''){
                google_search_url += '&cr='+cr_val;
            }
            if(lr_val!=''){
                google_search_url += '&lr='+lr_val;
            }
            google_search_url += '&num=100&ie=utf-8&oe=utf-8&hl=us&gl=us';
            //
            let _shangjia_info = {
                   '_shangjia_id': google_search_url,
                   '_shangjia_name': as_q_val_arr[i],
                   '_shangjia_a_link':google_search_url,
                   '_search_result': []
               };
            console.log(_shangjia_info);
            shangjia_infos.push(_shangjia_info);
            //
        }
        //
        var bg = chrome.extension.getBackgroundPage();
        bg.plugin_get_expire(function (callback_data) {
            let expire_date = callback_data['expire'];
            if (typeof expire_date === 'undefined') {
                $('.jihuo').show();
                $('#expire_date').html("<span style='color:red;'>已过期或未激活</span>");
                if(IS_TIEPAI) {
                    $('#message-account-info').html("<span style='color:red;'>已过期或未激活，联系客服！</span>");
                }else{
                    $('#message-account-info').html("<span style='color:red;'>已过期或未激活，</span><a href='https://www.gycharm.com/user/order-plugin' target='_blank'>续费或者购买后，</a> <span style='color:red;'>在下面输入框激活！</span>");
                }
                return;
            } else {
                expire_date = expire_date.replace('T00:00:00.000Z', '');
                $('#expire_date').html(expire_date);
                if (util_check_expire(expire_date)) {
                    $('.jihuo').show();
                    $('#expire_date').html("<span style='color:red;'>已过期或未激活</span>");
                    if(IS_TIEPAI) {
                        $('#message-account-info').html("<span style='color:red;'>已过期或未激活，联系客服！</span>");
                    }else{
                        $('#message-account-info').html("<span style='color:red;'>已过期或未激活，</span><a href='https://www.gycharm.com/user/order-plugin' target='_blank'>续费或者购买后，</a> <span style='color:red;'>在下面输入框激活！</span>");
                    }
                    return;
                }
            }
            //
            console.log(shangjia_infos);
            bg.shangjia_items_update(shangjia_infos);
            //
            window.alert('添加成功!');
            //
        });
        //
    });
}

google_search_batch();
//
function google_search_single(){
    console.log('google_search_single');
    console.log('a3');
    $('.form-google #form_google_submit,.form-google #form_google_image_submit,.form-google #form_google_videos_submit,.form-google #form_google_shopping_submit').click(function (){
        console.log('a2');
        var submit_id = $(this).attr('id');
        var bg = chrome.extension.getBackgroundPage();
        bg.plugin_get_expire(function (callback_data) {
            console.log('aa');
            let expire_date = callback_data['expire'];
            if (typeof expire_date === 'undefined') {
                $('.jihuo').show();
                $('#expire_date').html("<span style='color:red;'>已过期或未激活</span>");
                if(IS_TIEPAI) {
                    $('#message-account-info').html("<span style='color:red;'>已过期或未激活，联系客服！</span>");
                }else{
                    $('#message-account-info').html("<span style='color:red;'>已过期或未激活，</span><a href='https://www.gycharm.com/user/order-plugin' target='_blank'>续费或者购买后，</a> <span style='color:red;'>在下面输入框激活！</span>");
                }
                return;
            } else {
                expire_date = expire_date.replace('T00:00:00.000Z', '');
                $('#expire_date').html(expire_date);
                if (util_check_expire(expire_date)) {
                    $('.jihuo').show();
                    $('#expire_date').html("<span style='color:red;'>已过期或未激活</span>");
                    if(IS_TIEPAI) {
                        $('#message-account-info').html("<span style='color:red;'>已过期或未激活，联系客服！</span>");
                    }else{
                        $('#message-account-info').html("<span style='color:red;'>已过期或未激活，</span><a href='https://www.gycharm.com/user/order-plugin' target='_blank'>续费或者购买后，</a> <span style='color:red;'>在下面输入框激活！</span>");
                    }
                    return;
                }
            }
            //
            let as_q_val  = $('.form-google #as_q').val(); //关键词
            as_q_val = as_q_val.trim();
            as_q_val = as_q_val.trim();
            //分割
            as_q_val_arr = as_q_val.split(/[(\r\n)\r\n]+/);
            //去重
            if(as_q_val_arr.length>1){
                as_q_val_arr = Array.from(new Set(as_q_val_arr));
            }
            if(as_q_val_arr.length > 1){
                window.alert('Google单个搜、Google Images、Google Videos、Google Shopping搜，一次只支持一个关键词！');
                return;
            }
            //
            let as_epq_val = $('.form-google #as_epq').val(); //完全匹配词
            as_epq_val = as_epq_val.trim();
            let as_oq_val  = $('.form-google #as_oq').val(); //任意词
            as_oq_val = as_oq_val.trim();
            let as_eq_val = $('.form-google #as_eq').val(); //排除词
            as_eq_val = as_eq_val.trim();
            let cr_val = $('.form-google #cr').val(); //国家
            let lr_val = $('.form-google #lr').val(); //语言
            let as_nlo_val = $('.form-google #as_nlo').val(); //开始年份
            as_nlo_val = as_nlo_val.trim();
            let as_nhi_val = $('.form-google #as_nhi').val(); //结束年份
            as_nhi_val = as_nhi_val.trim();

            if(as_q_val==''){
                alert("关键词不能为空！");
                return false;
            }

            let google_search_url = util_getgooglewebiste_by_country(cr_val)+'search?';
            let q = as_q_val;

            if(as_oq_val!=''){
                let as_oq_val_list = as_oq_val.split(' ');
                let as_oq_val_list_new = [];
                for(let i=0;i<as_oq_val_list.length;i++){
                    let as_oq_val_temp = as_oq_val_list[i];
                    as_oq_val_temp = as_oq_val_temp.trim();
                    as_oq_val_list_new.push(as_oq_val_temp);
                }
                //
                q += '+';
                q += as_oq_val_list_new.join('+OR+')
                //
            }

            if(as_epq_val!=''){
                q += "+" + '"' + as_epq_val + '"'
            }

            if(as_eq_val!=''){
                let as_eq_val_list = as_eq_val.split(/[(\r\n)\r\n]+/);
                if(as_eq_val_list.length>0){
                    let as_eq_val_list_new = [];
                    for(let i=0;i<as_eq_val_list.length;i++){
                        let as_eq_val_temp = as_eq_val_list[i];
                        as_eq_val_temp = as_eq_val_temp.trim();
                        as_eq_val_list_new.push(as_eq_val_temp);
                    }
                    q += '+-';
                    q += as_eq_val_list_new.join("+-");
                }
            }
            google_search_url += 'q=' + q;
            if(as_nlo_val!=''){
                google_search_url += '&as_nlo='+as_nlo_val;
            }
            if(as_nhi_val!=''){
                google_search_url += '&as_nhi='+as_nhi_val;
            }
            if(cr_val!=''){
                google_search_url += '&cr='+cr_val;
            }
            if(lr_val!=''){
                google_search_url += '&lr='+lr_val;
            }
            google_search_url += '&num=100&ie=utf-8&oe=utf-8&hl=us&gl=us';
            //
            console.log('submit_id');
            console.log(submit_id);
            if(submit_id == 'form_google_image_submit'){
                google_search_url += '&safe=images&hl=en&source=lnms&tbm=isch&sa=X&biw=1232&bih=597&dpr=1.5';
            }else if(submit_id == 'form_google_videos_submit'){
                google_search_url += '&source=lnms&tbm=vid&sa=X&biw=1280&bih=601&dpr=1.5';
            }else if(submit_id == 'form_google_shopping_submit'){
                let google_search_shopping_url = 'https://www.google.com/search?';
                if(cr_val == 'countryJP'){
                    //google_search_shopping_url = 'https://www.google.co.jp/search?';
                }
                google_search_url = google_search_shopping_url+'q='+as_q_val+'&source=lnms&tbm=shop&sa=X&biw=1920&bih=937&dpr=1';
            }
            var bg = chrome.extension.getBackgroundPage();
            let google_keyword_values = {
                'as_q': as_q_val,
                'as_epq': as_epq_val,
                'as_oq':as_oq_val,
                'as_eq':as_eq_val,
                'cr':cr_val,
                'lr':lr_val,
                'as_nlo':as_nlo_val,
                'as_nhi':as_nhi_val
            };
            bg.google_keyword_set(google_keyword_values,function (){
               //
                chrome.tabs.create({ url: google_search_url});
                //
            });
            //
        });
        //
    });
    //
}
google_search_single();

function exportToExcel(data, fileName, sheetName) {
  // Create a new workbook
  var wb = XLSX.utils.book_new();

  // Convert your data to an array of arrays (2D array)
  var wsData = XLSX.utils.json_to_sheet(data);

  // Add the worksheet to the workbook
  XLSX.utils.book_append_sheet(wb, wsData, sheetName);

  // Generate the Excel file and trigger a download
  XLSX.writeFile(wb, fileName + ".xlsx");
}

/////////////////////
function google_search_export(){
    $('#form_google_export').click(function (){

        var bg = chrome.extension.getBackgroundPage();
        bg.plugin_get_expire(function (callback_data) {
            let expire_date = callback_data['expire'];
            if (typeof expire_date === 'undefined') {
                $('.jihuo').show();
                $('#expire_date').html("<span style='color:red;'>已过期或未激活</span>");

                if(IS_TIEPAI) {
                    $('#message-account-info').html("<span style='color:red;'>已过期或未激活，联系客服！</span>");
                }else{
                    $('#message-account-info').html("<span style='color:red;'>已过期或未激活，</span><a href='https://www.gycharm.com/user/order-plugin' target='_blank'>续费或者购买后，</a> <span style='color:red;'>在下面输入框激活！</span>");
                }

                return;
            } else {
                expire_date = expire_date.replace('T00:00:00.000Z', '');
                $('#expire_date').html(expire_date);
                if (util_check_expire(expire_date)) {
                    $('.jihuo').show();
                    $('#expire_date').html("<span style='color:red;'>已过期或未激活</span>");
                    if(IS_TIEPAI) {
                        $('#message-account-info').html("<span style='color:red;'>已过期或未激活，联系客服！</span>");
                    }else{
                        $('#message-account-info').html("<span style='color:red;'>已过期或未激活，</span><a href='https://www.gycharm.com/user/order-plugin' target='_blank'>续费或者购买后，</a> <span style='color:red;'>在下面输入框激活！</span>");
                    }
                    return;
                }
            }
            //
        chrome.tabs.getSelected(null, function (tab) {
            var current_url =  tab.url;
            if(current_url){
                if(current_url.indexOf('search')==-1){
                    alert('搜索后再导出！');
                    return;
                }
            }
        });
        $('#message-info').html('<span style="font-size: 12px;">导出需要花费时间，请保持界面不动,处理中...</span>');
       // popup ---> content
        chrome.tabs.query({
                        active: true,
                        currentWindow: true
                    }, (tabs) => {
                        let message = {
                            action: 'extract_google_search_export',
                            info: ''
                        }
                        chrome.tabs.sendMessage(tabs[0].id, message, res => {
                            console.log('popup=>content google_search_export')
                            console.log(res)
                            //
                            /*$("#dvjson").excelexportjs({
                                containerid: "dvjson"
                                   , datatype: 'json'
                                   , dataset: res['shangjia_infos']
                                   , columns: getColumns(res['shangjia_infos'])
                                   , filename: res['file_name']
                            });*/
                            //
                            exportToExcel(res['shangjia_infos'], res['file_name'], "Sheet1");
                            //
                            $('#message-info').html('');
                            //
                        })
            })
            //
        });
        //
    });
}
google_search_export();

function get_sns_plateform(sns_plateform_channel=''){
    var sns_plateform = '';
    if (sns_plateform_channel.indexOf('facebook') != -1){
        sns_plateform = 'sns_facebook';
    }else if(sns_plateform_channel.indexOf('twitter') != -1){
        sns_plateform = 'sns_twitter';
    }else if(sns_plateform_channel.indexOf('instagram') != -1) {
        sns_plateform = 'sns_instagram';
    }else if(sns_plateform_channel.indexOf('linkedin') != -1){
        sns_plateform = 'sns_linkedin';
    }else if(sns_plateform_channel.indexOf('youtube') != -1){
        sns_plateform = 'sns_youtube';
    }else if(sns_plateform_channel.indexOf('pinterest') != -1){
        sns_plateform = 'sns_pinterest';
    }else if(sns_plateform_channel.indexOf('tiktok') != -1){
        sns_plateform = 'sns_tiktok';
    }else if(sns_plateform_channel.indexOf('reddit') != -1){
        sns_plateform = 'sns_reddit';
    }else if(sns_plateform_channel.indexOf('sns_vk') != -1){
        sns_plateform = 'sns_vk';
    }else if(sns_plateform_channel.indexOf('sns_ok') != -1){
        sns_plateform = 'sns_ok';
    }
    return sns_plateform;
}

function sns_search(){
    $('.form-sns #form_sns_submit').click(function (){
        var bg = chrome.extension.getBackgroundPage();
        bg.plugin_get_expire(function (callback_data) {
            let expire_date = callback_data['expire'];
            if (typeof expire_date === 'undefined') {
                $('.jihuo').show();
                $('#expire_date').html("<span style='color:red;'>已过期或未激活</span>");

                if(IS_TIEPAI) {
                    $('#message-account-info').html("<span style='color:red;'>已过期或未激活，联系客服！</span>");
                }else{
                    $('#message-account-info').html("<span style='color:red;'>已过期或未激活，</span><a href='https://www.gycharm.com/user/order-plugin' target='_blank'>续费或者购买后，</a> <span style='color:red;'>在下面输入框激活！</span>");
                }

                return;
            } else {
                expire_date = expire_date.replace('T00:00:00.000Z', '');
                $('#expire_date').html(expire_date);
                if (util_check_expire(expire_date)) {
                    $('.jihuo').show();
                    $('#expire_date').html("<span style='color:red;'>已过期或未激活</span>");
                    if(IS_TIEPAI) {
                        $('#message-account-info').html("<span style='color:red;'>已过期或未激活，联系客服！</span>");
                    }else{
                        $('#message-account-info').html("<span style='color:red;'>已过期或未激活，</span><a href='https://www.gycharm.com/user/order-plugin' target='_blank'>续费或者购买后，</a> <span style='color:red;'>在下面输入框激活！</span>");
                    }
                    return;
                }
            }
            //
            let as_q = $('.form-sns #as_q').val();
            as_q = as_q.trim();
            let sns_plateform_val = $('.form-sns select[name="sns"]').val();
            if(as_q==''){
                alert("关键词不能为空！");
                return false;
            }
            if(sns_plateform_val==''){
                alert("请选择一个社媒渠道！");
                return false;
            }
            let channel = sns_plateform_val;
            let sns_plateform = get_sns_plateform(channel);

            let url = '';
            if(sns_plateform == 'sns_facebook') {
                if (channel == 'sns_facebook_home') {
                    url = 'https://www.google.com/search?';
                    as_q_value = as_q;
                    as_q_value_list = as_q_value.split(' ');
                    as_q_str = as_q_value_list.join("+");
                    url += 'q=' + as_q_str + '+intext:("www"|"http"|"https")+intitle:Home+-inurl:pages+site:facebook.com';
                    url += '&num=100&ie=utf-8&oe=utf-8&hl=us&gl=us';
                } else if (channel == 'sns_facebook_videos') {
                    url = 'https://www.google.com/search?'
                    as_q_value = as_q;
                    as_q_value_list = as_q_value.split(' ');
                    as_q_str = as_q_value_list.join("+");
                    url += 'q=' + as_q_str + '+intext:("www"|"http"|"https")+inurl:videos+site:facebook.com';
                    url += '&num=100&ie=utf-8&oe=utf-8&hl=us&gl=us'
                } else if (channel == 'sns_facebook_posts') {
                    url = 'https://www.google.com/search?';
                    as_q_value = as_q;
                    as_q_value_list = as_q_value.split(' ');
                    as_q_str = as_q_value_list.join("+");
                    url += 'q=' + as_q_str + '+intext:("www"|"http"|"https")+inurl:posts+site:facebook.com';
                    url += '&num=100&ie=utf-8&oe=utf-8&hl=us&gl=us';
                } else if (channel == 'sns_facebook_photos') {
                    url = 'https://www.google.com/search?';
                    as_q_value = as_q;
                    as_q_value_list = as_q_value.split(' ');
                    as_q_str = as_q_value_list.join("+");
                    url += 'q=' + as_q_str + '+intext:("www"|"http"|"https")+inurl:photos+site:facebook.com';
                    url += '&num=100&ie=utf-8&oe=utf-8&hl=us&gl=us';
                } else if (channel == 'sns_facebook_hashtag') {
                    url = 'https://www.google.com/search?';
                    as_q_value = as_q;
                    as_q_value_list = as_q_value.split(' ');
                    as_q_str = as_q_value_list.join("+");
                    url += 'q=' + as_q_str + '+intext:("www"|"http"|"https")+inurl:hashtag+site:facebook.com';
                    url += '&num=100&ie=utf-8&oe=utf-8&hl=us&gl=us';
                } else if (channel == 'sns_facebook_pages') {
                    url = 'https://www.google.com/search?';
                    as_q_value = as_q;
                    as_q_value_list = as_q_value.split(' ');
                    as_q_str = as_q_value_list.join("+");
                    url += 'q=' + as_q_str + '+intext:("www"|"http"|"https")+inurl:pages+site:facebook.com';
                    url += '&num=100&ie=utf-8&oe=utf-8&hl=us&gl=us';
                } else if (channel == 'sns_facebook_groups') {
                    url = 'https://www.google.com/search?';
                    as_q_value = as_q;
                    as_q_value_list = as_q_value.split(' ');
                    as_q_str = as_q_value_list.join("+");
                    url += 'q=' + as_q_str + '+intext:("www"|"http"|"https")+inurl:groups+site:facebook.com';
                    url += '&num=100&ie=utf-8&oe=utf-8&hl=us&gl=us';
                } else if (channel == 'sns_facebook_reviews') {
                    url = 'https://www.google.com/search?';
                    as_q_value = as_q;
                    as_q_value_list = as_q_value.split(' ');
                    as_q_str = as_q_value_list.join("+");
                    url += 'q=' + as_q_str + '+intext:("www"|"http"|"https")+inurl:reviews+site:facebook.com';
                    url += '&num=100&ie=utf-8&oe=utf-8&hl=us&gl=us';
                } else if (channel == 'sns_facebook_marketplace') {
                    url = 'https://www.google.com/search?';
                    as_q_value = as_q;
                    as_q_value_list = as_q_value.split(' ');
                    as_q_str = as_q_value_list.join("+");
                    url += 'q=' + as_q_str + '+intext:("www"|"http"|"https")+inurl:marketplace+site:facebook.com';
                    url += '&num=100&ie=utf-8&oe=utf-8&hl=us&gl=us';
                } else if (channel == 'sns_facebook_events') {
                    url = 'https://www.google.com/search?';
                    as_q_value = as_q;
                    as_q_value_list = as_q_value.split(' ');
                    as_q_str = as_q_value_list.join("+");
                    url += 'q=' + as_q_str + '+intext:("www"|"http"|"https")+inurl:events+site:facebook.com';
                    url += '&num=100&ie=utf-8&oe=utf-8&hl=us&gl=us';
                } else if (channel == 'sns_facebook_people') {
                    url = 'https://www.google.com/search?';
                    as_q_value = as_q;
                    as_q_value_list = as_q_value.split(' ');
                    as_q_str = as_q_value_list.join("+");
                    url += 'q=' + as_q_str + '+intext:("www"|"http"|"https")+inurl:people+site:facebook.com';
                    url += '&num=100&ie=utf-8&oe=utf-8&hl=us&gl=us';
                } else if (channel == 'sns_facebook_shop') {
                    url = 'https://www.google.com/search?';
                    as_q_value = as_q;
                    as_q_value_list = as_q_value.split(' ');
                    as_q_str = as_q_value_list.join("+");
                    url += 'q=' + as_q_str + '+intext:("www"|"http"|"https")+site:facebook.com/commerce/prducts';
                    url += '&num=100&ie=utf-8&oe=utf-8&hl=us&gl=us';
                }
            }else if(sns_plateform == 'sns_twitter') {
                if (channel == 'sns_twitter_home') {
                    url = 'https://www.google.com/search?';
                    as_q_value = as_q;
                    as_q_value_list = as_q_value.split(' ');
                    as_q_str = as_q_value_list.join("+");
                    url += 'q=' + as_q_str + '+intext:("www"|"http"|"https")+-inurl:(status|hashtag|search|with_replies|statuses|jobs)+-intitle:(job|jobs)+site:twitter.com';
                    url += '&num=100&ie=utf-8&oe=utf-8&hl=us&gl=us';
                } else if (channel == 'sns_twitter_post') {
                    url = 'https://www.google.com/search?';
                    as_q_value = as_q;
                    as_q_value_list = as_q_value.split(' ');
                    as_q_str = as_q_value_list.join("+");
                    url += 'q=' + as_q_str + '+intext:("www"|"http"|"https")+inurl:(status|with_replies)+site:twitter.com';
                    url += '&num=100&ie=utf-8&oe=utf-8&hl=us&gl=us';
                } else if (channel == 'sns_twitter_hashtag') {
                    url = 'https://www.google.com/search?';
                    as_q_value = as_q;
                    as_q_value_list = as_q_value.split(' ');
                    as_q_str = as_q_value_list.join("+");
                    url += 'q=' + as_q_str + '+intext:("www"|"http"|"https")+inurl:(search|hashtag)+site:twitter.com';
                    url += '&num=100&ie=utf-8&oe=utf-8&hl=us&gl=us';
                }
            }else if(sns_plateform == 'sns_instagram') {
                if (channel == 'sns_instagram_home') {
                    url = 'https://www.google.com/search?';
                    as_q_value = as_q;
                    as_q_value_list = as_q_value.split(' ');
                    as_q_str = as_q_value_list.join("+");
                    url += 'q=' + as_q_str + '+intext:("www"|"http"|"https")+-inurl:(p|tv|tags|channel|reels|feed)+site:instagram.com';
                    url += '&num=100&ie=utf-8&oe=utf-8&hl=us&gl=us';
                } else if (channel == 'sns_instagram_post') {
                    url = 'https://www.google.com/search?';
                    as_q_value = as_q;
                    as_q_value_list = as_q_value.split(' ');
                    as_q_str = as_q_value_list.join("+");
                    url += 'q=' + as_q_str + '+intext:("www"|"http"|"https")+inurl:(p)+site:instagram.com';
                    url += '&num=100&ie=utf-8&oe=utf-8&hl=us&gl=us';
                } else if (channel == 'sns_instagram_tag') {
                    url = 'https://www.google.com/search?';
                    as_q_value = as_q;
                    as_q_value_list = as_q_value.split(' ');
                    as_q_str = as_q_value_list.join("+");
                    url += 'q=' + as_q_str + '+intext:("www"|"http"|"https")+inurl:(tags)+site:instagram.com';
                    url += '&num=100&ie=utf-8&oe=utf-8&hl=us&gl=us';
                } else if (channel == 'sns_instagram_channel') {
                    url = 'https://www.google.com/search?';
                    as_q_value = as_q;
                    as_q_value_list = as_q_value.split(' ');
                    as_q_str = as_q_value_list.join("+");
                    url += 'q=' + as_q_str + '+intext:("www"|"http"|"https")+inurl:(channel)+site:instagram.com';
                    url += '&num=100&ie=utf-8&oe=utf-8&hl=us&gl=us';
                } else if (channel == 'sns_instagram_tv') {
                    url = 'https://www.google.com/search?';
                    as_q_value = as_q;
                    as_q_value_list = as_q_value.split(' ');
                    as_q_str = as_q_value_list.join("+");
                    url += 'q=' + as_q_str + '+intext:("www"|"http"|"https")+inurl:(tv)+site:instagram.com';
                    url += '&num=100&ie=utf-8&oe=utf-8&hl=us&gl=us';
                }
            }else if(sns_plateform == 'sns_linkedin') {
                if (channel == 'sns_linkedin_company') {
                    url = 'https://www.google.com/search?';
                    as_q_value = as_q;
                    as_q_value_list = as_q_value.split(' ');
                    as_q_str = as_q_value_list.join("+");
                    url += 'q=' + as_q_str + '+intext:("www"|"http"|"https")+site:linkedin.com/company/';
                    url += '&num=100&ie=utf-8&oe=utf-8&hl=us&gl=us';
                } else if (channel == 'sns_linkedin_in') {
                    url = 'https://www.google.com/search?';
                    as_q_value = as_q;
                    as_q_value_list = as_q_value.split(' ');
                    as_q_str = as_q_value_list.join("+");
                    url += 'q=' + as_q_str + '+intext:("www"|"http"|"https")+site:linkedin.com/in/';
                    url += '&num=100&ie=utf-8&oe=utf-8&hl=us&gl=us';
                } else if (channel == 'sns_linkedin_post') {
                    url = 'https://www.google.com/search?';
                    as_q_value = as_q;
                    as_q_value_list = as_q_value.split(' ');
                    as_q_str = as_q_value_list.join("+");
                    url += 'q=' + as_q_str + '+intext:("www"|"http"|"https")+site:linkedin.com/posts/';
                    url += '&num=100&ie=utf-8&oe=utf-8&hl=us&gl=us';
                } else if (channel == 'sns_linkedin_pulse') {
                    url = 'https://www.google.com/search?';
                    as_q_value = as_q;
                    as_q_value_list = as_q_value.split(' ');
                    as_q_str = as_q_value_list.join("+");
                    url += 'q=' + as_q_str + '+intext:("www"|"http"|"https")+site:linkedin.com/pulse/';
                    url += '&num=100&ie=utf-8&oe=utf-8&hl=us&gl=us';
                }
            } else if(sns_plateform == 'sns_youtube') {
                if (channel == 'sns_youtube_home') {
                    url = 'https://www.google.com/search?';
                    as_q_value = as_q;
                    as_q_value_list = as_q_value.split(' ');
                    as_q_str = as_q_value_list.join("+");
                    url += 'q=' + as_q_str + '+intext:("www"|"http"|"https")+-inurl:(watch|hashtag|video|playlist|videos|shorts|playlists|post|about)+site:youtube.com';
                    url += '&num=100&ie=utf-8&oe=utf-8&hl=us&gl=us';
                } else if (channel == 'sns_youtube_about') {
                    url = 'https://www.google.com/search?';
                    as_q_value = as_q;
                    as_q_value_list = as_q_value.split(' ');
                    as_q_str = as_q_value_list.join("+");
                    url += 'q=' + as_q_str + '+intext:("www"|"http"|"https")+inurl:(about)+site:youtube.com';
                    url += '&num=100&ie=utf-8&oe=utf-8&hl=us&gl=us';
                } else if (channel == 'sns_youtube_watch') {
                    url = 'https://www.google.com/search?';
                    as_q_value = as_q;
                    as_q_value_list = as_q_value.split(' ');
                    as_q_str = as_q_value_list.join("+");
                    url += 'q=' + as_q_str + '+intext:("www"|"http"|"https")+inurl:(watch)+site:youtube.com';
                    url += '&num=100&ie=utf-8&oe=utf-8&hl=us&gl=us';
                } else if (channel == 'sns_youtube_shorts') {
                    url = 'https://www.google.com/search?';
                    as_q_value = as_q;
                    as_q_value_list = as_q_value.split(' ');
                    as_q_str = as_q_value_list.join("+");
                    url += 'q=' + as_q_str + '+intext:("www"|"http"|"https")+inurl:(shorts)+site:youtube.com';
                    url += '&num=100&ie=utf-8&oe=utf-8&hl=us&gl=us';
                } else if (channel == 'sns_youtube_hashtag') {
                    url = 'https://www.google.com/search?';
                    as_q_value = as_q;
                    as_q_value_list = as_q_value.split(' ');
                    as_q_str = as_q_value_list.join("+");
                    url += 'q=' + as_q_str + '+intext:("www"|"http"|"https")+inurl:(hashtag)+site:youtube.com';
                    url += '&num=100&ie=utf-8&oe=utf-8&hl=us&gl=us';
                } else if (channel == 'sns_youtube_watch') {
                    url = 'https://www.google.com/search?';
                    as_q_value = as_q;
                    as_q_value_list = as_q_value.split(' ');
                    as_q_str = as_q_value_list.join("+");
                    url += 'q=' + as_q_str + '+intext:("www"|"http"|"https")+inurl:(videos)+-inurl:watch+site:youtube.com';
                    url += '&num=100&ie=utf-8&oe=utf-8&hl=us&gl=us';
                } else if (channel == 'sns_youtube_playlists') {
                    url = 'https://www.google.com/search?';
                    as_q_value = as_q;
                    as_q_value_list = as_q_value.split(' ');
                    as_q_str = as_q_value_list.join("+");
                    url += 'q=' + as_q_str + '+intext:("www"|"http"|"https")+inurl:(playlist|playlists)+site:youtube.com';
                    url += '&num=100&ie=utf-8&oe=utf-8&hl=us&gl=us';
                }
            }else if(sns_plateform == 'sns_pinterest') {
                if (channel == 'sns_pinterest_home') {
                    url = 'https://www.google.com/search?';
                    as_q_value = as_q;
                    as_q_value_list = as_q_value.split(' ');
                    as_q_str = as_q_value_list.join("+");
                    url += 'q=' + as_q_str + '+intext:("www"|"http"|"https")+-inurl:pin+site:pinterest.com';
                    url += '&num=100&ie=utf-8&oe=utf-8&hl=us&gl=us';
                } else if (channel == 'sns_pinterest_pin') {
                    url = 'https://www.google.com/search?';
                    as_q_value = as_q;
                    as_q_value_list = as_q_value.split(' ');
                    as_q_str = as_q_value_list.join("+");
                    url += 'q=' + as_q_str + '+intext:("www"|"http"|"https")+inurl:pin+site:pinterest.com';
                    url += '&num=100&ie=utf-8&oe=utf-8&hl=us&gl=us';
                }
            }else if(sns_plateform == 'sns_tiktok') {
                if (channel == 'sns_tiktok_home') {
                    url = 'https://www.google.com/search?';
                    as_q_value = as_q;
                    as_q_value_list = as_q_value.split(' ');
                    as_q_str = as_q_value_list.join("+");
                    url += 'q=' + as_q_str + '+intext:("www"|"http"|"https")+-inurl:(discover|tag|video|music|question|link)+site:tiktok.com';
                    url += '&num=100&ie=utf-8&oe=utf-8&hl=us&gl=us';
                } else if (channel == 'sns_tiktok_video') {
                    url = 'https://www.google.com/search?';
                    as_q_value = as_q;
                    as_q_value_list = as_q_value.split(' ');
                    as_q_str = as_q_value_list.join("+");
                    url += 'q=' + as_q_str + '+intext:("www"|"http"|"https")+inurl:video+-discover+site:tiktok.com';
                    url += '&num=100&ie=utf-8&oe=utf-8&hl=us&gl=us';
                } else if (channel == 'sns_tiktok_tag') {
                    url = 'https://www.google.com/search?';
                    as_q_value = as_q;
                    as_q_value_list = as_q_value.split(' ');
                    as_q_str = as_q_value_list.join("+");
                    url += 'q=' + as_q_str + '+intext:("www"|"http"|"https")+inurl:tag+-inurl:question+site:tiktok.com';
                    url += '&num=100&ie=utf-8&oe=utf-8&hl=us&gl=us';
                } else if (channel == 'sns_tiktok_discover') {
                    url = 'https://www.google.com/search?';
                    as_q_value = as_q;
                    as_q_value_list = as_q_value.split(' ');
                    as_q_str = as_q_value_list.join("+");
                    url += 'q=' + as_q_str + '+intext:("www"|"http"|"https")+inurl:discover+site:tiktok.com';
                    url += '&num=100&ie=utf-8&oe=utf-8&hl=us&gl=us';
                } else if (channel == 'sns_tiktok_question') {
                    url = 'https://www.google.com/search?';
                    as_q_value = as_q;
                    as_q_value_list = as_q_value.split(' ');
                    as_q_str = as_q_value_list.join("+");
                    url += 'q=' + as_q_str + '+intext:("www"|"http"|"https")+inurl:question+-inurl:discover+site:tiktok.com';
                    url += '&num=100&ie=utf-8&oe=utf-8&hl=us&gl=us';
                }
            }else if(sns_plateform == 'sns_reddit') {
                if (channel == 'sns_reddit_home') {
                    url = 'https://www.google.com/search?';
                    as_q_value = as_q;
                    as_q_value_list = as_q_value.split(' ');
                    as_q_str = as_q_value_list.join("+");
                    url += 'q=' + as_q_str + '+intext:("www"|"http"|"https")+inurl:user+-inurl:comments+site:reddit.com';
                    url += '&num=100&ie=utf-8&oe=utf-8&hl=us&gl=us';
                } else if (channel == 'sns_reddit_forum') {
                    url = 'https://www.google.com/search?';
                    as_q_value = as_q;
                    as_q_value_list = as_q_value.split(' ');
                    as_q_str = as_q_value_list.join("+");
                    url += 'q=' + as_q_str + '+intext:("www"|"http"|"https")+inurl:r+-inurl:comments+site:reddit.com';
                    url += '&num=100&ie=utf-8&oe=utf-8&hl=us&gl=us';
                } else if (channel == 'sns_reddit_comments') {
                    url = 'https://www.google.com/search?';
                    as_q_value = as_q;
                    as_q_value_list = as_q_value.split(' ');
                    as_q_str = as_q_value_list.join("+");
                    url += 'q=' + as_q_str + '+intext:("www"|"http"|"https")+inurl:comments+site:reddit.com';
                    url += '&num=100&ie=utf-8&oe=utf-8&hl=us&gl=us';
                }
            }else if (sns_plateform == 'sns_vk') {
                if (channel == 'sns_vk_home') {
                    url = 'https://www.google.com/search?';
                    as_q_value = as_q;
                    as_q_value_list = as_q_value.split(' ');
                    as_q_str = as_q_value_list.join("+");
                    url += 'q=' + as_q_str + '+intext:("www"|"http"|"https")+-inurl:(video|market|wall|away)+site:vk.ru';
                    url += '&num=100&ie=utf-8&oe=utf-8&hl=us&gl=us';
                } else if (channel == 'sns_vk_post') {
                    url = 'https://www.google.com/search?';
                    as_q_value = as_q;
                    as_q_value_list = as_q_value.split(' ');
                    as_q_str = as_q_value_list.join("+");
                    url += 'q=' + as_q_str + '+intext:("www"|"http"|"https")+site:vk.com/wall';
                    url += '&num=100&ie=utf-8&oe=utf-8&hl=us&gl=us';
                } else if (channel == 'sns_vk_article') {
                    url = 'https://www.google.com/search?';
                    as_q_value = as_q;
                    as_q_value_list = as_q_value.split(' ');
                    as_q_str = as_q_value_list.join("+");
                    url += 'q=' + as_q_str + '+intext:("www"|"http"|"https")+site:vk.com/@';
                    url += '&num=100&ie=utf-8&oe=utf-8&hl=us&gl=us';
                } else if (channel == 'sns_vk_product') {
                    url = 'https://www.google.com/search?';
                    as_q_value = as_q;
                    as_q_value_list = as_q_value.split(' ');
                    as_q_str = as_q_value_list.join("+");
                    url += 'q=' + as_q_str + '+intext:("www"|"http"|"https")+site:vk.com/market';
                    url += '&num=100&ie=utf-8&oe=utf-8&hl=us&gl=us';
                } else if (channel == 'sns_vk_video') {
                    url = 'https://www.google.com/search?';
                    as_q_value = as_q;
                    as_q_value_list = as_q_value.split(' ');
                    as_q_str = as_q_value_list.join("+");
                    url += 'q=' + as_q_str + '+intext:("www"|"http"|"https")+site:vk.com/video';
                    url += '&num=100&ie=utf-8&oe=utf-8&hl=us&gl=us';
                } else if (channel == 'sns_vk_link') {
                    url = 'https://www.google.com/search?';
                    as_q_value = as_q;
                    as_q_value_list = as_q_value.split(' ');
                    as_q_str = as_q_value_list.join("+");
                    url += 'q=' + as_q_str + '+intext:("www"|"http"|"https")+site:vk.com/away.php';
                    url += '&num=100&ie=utf-8&oe=utf-8&hl=us&gl=us';
                } else if (channel == 'sns_vk_doc') {
                    url = 'https://www.google.com/search?';
                    as_q_value = as_q;
                    as_q_value_list = as_q_value.split(' ');
                    as_q_str = as_q_value_list.join("+");
                    url += 'q=' + as_q_str + '+intext:("www"|"http"|"https")+site:vk.com/doc';
                    url += '&num=100&ie=utf-8&oe=utf-8&hl=us&gl=us';
                }
            }else if (sns_plateform == 'sns_ok') {
                if (channel == 'sns_ok_post') {
                    url = 'https://www.google.com/search?';
                    as_q_value = as_q;
                    as_q_value_list = as_q_value.split(' ');
                    as_q_str = as_q_value_list.join("+");
                    url += 'q=' + as_q_str + '+intext:("www"|"http"|"https")+site:ok.ru/*/statuses';
                    url += '&num=100&ie=utf-8&oe=utf-8&hl=us&gl=us';
                } else if (channel == 'sns_ok_product') {
                    url = 'https://www.google.com/search?';
                    as_q_value = as_q;
                    as_q_value_list = as_q_value.split(' ');
                    as_q_str = as_q_value_list.join("+");
                    url += 'q=' + as_q_str + '+intext:("www"|"http"|"https")+site:ok.ru/profile/*/market';
                    url += '&num=100&ie=utf-8&oe=utf-8&hl=us&gl=us';
                } else if (channel == 'sns_ok_video') {
                    url = 'https://www.google.com/search?';
                    as_q_value = as_q;
                    as_q_value_list = as_q_value.split(' ');
                    as_q_str = as_q_value_list.join("+");
                    url += 'q=' + as_q_str + '+intext:("www"|"http"|"https")+site:ok.ru/*/video';
                    url += '&num=100&ie=utf-8&oe=utf-8&hl=us&gl=us';
                } else if (channel == 'sns_ok_group') {
                    url = 'https://www.google.com/search?';
                    as_q_value = as_q;
                    as_q_value_list = as_q_value.split(' ');
                    as_q_str = as_q_value_list.join("+");
                    url += 'q=' + as_q_str + '+intext:("www"|"http"|"https")+site:ok.ru/group';
                    url += '&num=100&ie=utf-8&oe=utf-8&hl=us&gl=us';
                } else if (channel == 'sns_ok_group_product') {
                    url = 'https://www.google.com/search?';
                    as_q_value = as_q;
                    as_q_value_list = as_q_value.split(' ');
                    as_q_str = as_q_value_list.join("+");
                    url += 'q=' + as_q_str + '+intext:("www"|"http"|"https")+site:ok.ru/group/*/product';
                    url += '&num=100&ie=utf-8&oe=utf-8&hl=us&gl=us';
                } else if (channel == 'sns_ok_group_topic') {
                    url = 'https://www.google.com/search?';
                    as_q_value = as_q;
                    as_q_value_list = as_q_value.split(' ');
                    as_q_str = as_q_value_list.join("+");
                    url += 'q=' + as_q_str + '+intext:("www"|"http"|"https")+site:ok.ru/group/*/topic';
                    url += '&num=100&ie=utf-8&oe=utf-8&hl=us&gl=us';
                } else if (channel == 'sns_ok_group_photo') {
                    url = 'https://www.google.com/search?';
                    as_q_value = as_q;
                    as_q_value_list = as_q_value.split(' ');
                    as_q_str = as_q_value_list.join("+");
                    url += 'q=' + as_q_str + '+intext:("www"|"http"|"https")+site:ok.ru/group/*/album';
                    url += '&num=100&ie=utf-8&oe=utf-8&hl=us&gl=us';
                }
            }
            //
            var bg = chrome.extension.getBackgroundPage();
            let google_sns_keywords = {
                'as_q': as_q,
                'sns_plateform_val': sns_plateform_val,
            };
            bg.google_sns_keyword_set(google_sns_keywords,function (){
               //
                chrome.tabs.create({ url: url});
                //
            });
            //
        });
        //
    });
}
sns_search();

function sns_export(){
    $('#form_sns_export').click(function (){
        var bg = chrome.extension.getBackgroundPage();
        bg.plugin_get_expire(function (callback_data) {
            let expire_date = callback_data['expire'];
            if (typeof expire_date === 'undefined') {
                $('.jihuo').show();
                $('#expire_date').html("<span style='color:red;'>已过期或未激活</span>");

                if(IS_TIEPAI) {
                    $('#message-account-info').html("<span style='color:red;'>已过期或未激活，联系客服！</span>");
                }else{
                    $('#message-account-info').html("<span style='color:red;'>已过期或未激活，</span><a href='https://www.gycharm.com/user/order-plugin' target='_blank'>续费或者购买后，</a> <span style='color:red;'>在下面输入框激活！</span>");
                }

                return;
            } else {
                expire_date = expire_date.replace('T00:00:00.000Z', '');
                $('#expire_date').html(expire_date);
                if (util_check_expire(expire_date)) {
                    $('.jihuo').show();
                    $('#expire_date').html("<span style='color:red;'>已过期或未激活</span>");

                    if(IS_TIEPAI) {
                        $('#message-account-info').html("<span style='color:red;'>已过期或未激活，联系客服！</span>");
                    }else{
                        $('#message-account-info').html("<span style='color:red;'>已过期或未激活，</span><a href='https://www.gycharm.com/user/order-plugin' target='_blank'>续费或者购买后，</a> <span style='color:red;'>在下面输入框激活！</span>");
                    }
                    return;
                }
            }
            //
            chrome.tabs.getSelected(null, function (tab) {
                var current_url =  tab.url;
                if(current_url){
                    if(current_url.indexOf('search')==-1){
                        alert('搜索后再导出！');
                        return;
                    }
                }
            });
            $('#message-info').html('<span style="font-size: 12px;">导出需要花费时间，请保持界面不动,处理中...</span>');
            // popup ---> content
            chrome.tabs.query({
                        active: true,
                        currentWindow: true
                    }, (tabs) => {
                        let message = {
                            action: 'extract_sns_export',
                            info: ''
                        }
                        chrome.tabs.sendMessage(tabs[0].id, message, res => {
                            console.log('popup=>content sns export')
                            console.log(res)
                            //
                            /*$("#dvjson").excelexportjs({
                                containerid: "dvjson"
                                   , datatype: 'json'
                                   , dataset: res['shangjia_infos']
                                   , columns: getColumns(res['shangjia_infos'])
                                   , filename: res['file_name']
                            });*/
                            //
                            exportToExcel(res['shangjia_infos'], 'data-sns-export-'+Date.now(), "Sheet1");
                            //
                            $('#message-info').html('');
                            //
                        })
            })
            //
        });
    });
}
sns_export();

function shopify_search(){
    $('.form-shopify #form_shopify_submit').click(function (){
        var bg = chrome.extension.getBackgroundPage();
        bg.plugin_get_expire(function (callback_data) {
            let expire_date = callback_data['expire'];
            if (typeof expire_date === 'undefined') {
                $('.jihuo').show();
                $('#expire_date').html("<span style='color:red;'>已过期或未激活</span>");

                if(IS_TIEPAI) {
                    $('#message-account-info').html("<span style='color:red;'>已过期或未激活，联系客服！</span>");
                }else{
                    $('#message-account-info').html("<span style='color:red;'>已过期或未激活，</span><a href='https://www.gycharm.com/user/order-plugin' target='_blank'>续费或者购买后，</a> <span style='color:red;'>在下面输入框激活！</span>");
                }

                return;
            } else {
                expire_date = expire_date.replace('T00:00:00.000Z', '');
                $('#expire_date').html(expire_date);
                if (util_check_expire(expire_date)) {
                    $('.jihuo').show();
                    $('#expire_date').html("<span style='color:red;'>已过期或未激活</span>");

                    if(IS_TIEPAI) {
                        $('#message-account-info').html("<span style='color:red;'>已过期或未激活，联系客服！</span>");
                    }else{
                        $('#message-account-info').html("<span style='color:red;'>已过期或未激活，</span><a href='https://www.gycharm.com/user/order-plugin' target='_blank'>续费或者购买后，</a> <span style='color:red;'>在下面输入框激活！</span>");
                    }
                    return;
                }
            }
            //
            let as_q = $('.form-shopify #as_q').val();
            as_q = as_q.trim().replace("\\", '');
            if(as_q==''){
                alert("关键词不能为空！");
                return false;
            }
            let sns_shopify_country_val = $('.form-shopify select[name="shopify_country"]').val();
            let sns_shopify_tech_val = $('.form-shopify select[name="shopify_tech"]').val();
            //
            let url = 'https://www.google.com/search?';
            if(sns_shopify_tech_val == 'tech_shopify'){
                q = 'q='+as_q;
                q += '+'+'inurl:collections+site:*'+sns_shopify_country_val+'+-wigs.com+-pinterest+-ebay+-walmart+-amazon+-facebook+-yelp+-instagram';
                url += q
                url += '&num=100&ie=utf-8&oe=utf-8';
            }
            //
            var bg = chrome.extension.getBackgroundPage();
            let google_shopify_keywords = {
                'as_q': as_q,
                'shopify_country': sns_shopify_country_val,
                'shopify_tech': sns_shopify_tech_val
            };
            bg.google_shopify_keyword_set(google_shopify_keywords,function (){
               //
                chrome.tabs.create({ url: url});
                //
            });
            //
        });
        //
    });
}
shopify_search();

function shopify_export(){
    $('#form_shopify_export').click(function (){
        var bg = chrome.extension.getBackgroundPage();
        bg.plugin_get_expire(function (callback_data) {
            let expire_date = callback_data['expire'];
            if (typeof expire_date === 'undefined') {
                $('.jihuo').show();
                $('#expire_date').html("<span style='color:red;'>已过期或未激活</span>");

                if(IS_TIEPAI) {
                    $('#message-account-info').html("<span style='color:red;'>已过期或未激活，联系客服！</span>");
                }else{
                    $('#message-account-info').html("<span style='color:red;'>已过期或未激活，</span><a href='https://www.gycharm.com/user/order-plugin' target='_blank'>续费或者购买后，</a> <span style='color:red;'>在下面输入框激活！</span>");
                }
                return;
            } else {
                expire_date = expire_date.replace('T00:00:00.000Z', '');
                $('#expire_date').html(expire_date);
                if (util_check_expire(expire_date)) {
                    $('.jihuo').show();
                    $('#expire_date').html("<span style='color:red;'>已过期或未激活</span>");

                    if(IS_TIEPAI) {
                        $('#message-account-info').html("<span style='color:red;'>已过期或未激活，联系客服！</span>");
                    }else{
                        $('#message-account-info').html("<span style='color:red;'>已过期或未激活，</span><a href='https://www.gycharm.com/user/order-plugin' target='_blank'>续费或者购买后，</a> <span style='color:red;'>在下面输入框激活！</span>");
                    }
                    return;
                }
            }
            //
            chrome.tabs.getSelected(null, function (tab) {
                var current_url =  tab.url;
                if(current_url){
                    if(current_url.indexOf('search')==-1){
                        alert('搜索后再导出！');
                        return;
                    }
                }
            });
            $('#message-info').html('<span style="font-size: 12px;">导出需要花费时间，请保持界面不动,处理中...</span>');
            // popup ---> content
            chrome.tabs.query({
                        active: true,
                        currentWindow: true
                    }, (tabs) => {
                        let message = {
                            action: 'extract_shopify_export',
                            info: ''
                        }
                        chrome.tabs.sendMessage(tabs[0].id, message, res => {
                            console.log('popup=>content sns export')
                            console.log(res);
                            //
                            /*$("#dvjson").excelexportjs({
                                containerid: "dvjson"
                                   , datatype: 'json'
                                   , dataset: res['shangjia_infos']
                                   , columns: getColumns(res['shangjia_infos'])
                                   , filename: res['file_name']
                            });*/
                            //
                            exportToExcel(res['shangjia_infos'], 'data-shopify-export-'+Date.now(), "Sheet1");
                            //
                            $('#message-info').html('');
                            //
                        })
            })
            //
        });
    });
}
shopify_export();


function init_search_customer(){
    var bg = chrome.extension.getBackgroundPage();
    bg.google_keyword_get(function (callback_data) {
            let google_keywords = callback_data['google_keywords'];
            if (typeof google_keywords !== 'undefined') {
                let as_q_val = google_keywords['as_q'];
                let as_epq_val = google_keywords['as_epq'];
                let as_oq_val  = google_keywords['as_oq'];
                let as_eq_val = google_keywords['as_eq'];
                let cr_val = google_keywords['cr'];
                let lr_val = google_keywords['lr'];
                let as_nlo_val = google_keywords['as_nlo'];
                let as_nhi_val  = google_keywords['as_nhi'];

                $('.form-google #as_q').val(as_q_val);
                $('.form-google #as_epq').val(as_epq_val);
                $('.form-google #as_oq').val(as_oq_val);
                $('.form-google #as_eq').val(as_eq_val);
                $(".form-google #cr").val(cr_val);
                $(".form-google #lr").val(lr_val);
                $(".form-google #as_nlo").val(as_nlo_val);
                $(".form-google #as_nhi").val(as_nhi_val);

            }
    });

    bg.google_sns_keyword_get(function (callback_data) {
            let google_sns_keywords = callback_data['google_sns_keywords'];
            if (typeof google_sns_keywords !== 'undefined') {
                let as_q_val = google_sns_keywords['as_q'];
                let sns_plateform_val = google_sns_keywords['sns_plateform_val'];

                $('.form-sns #as_q').val(as_q_val);
                $('.form-sns #sns_plateform').val(sns_plateform_val);

            }
    });

    bg.google_shopify_keyword_get(function (callback_data) {
            let google_shopify_keywords = callback_data['google_shopify_keywords'];
            if (typeof google_shopify_keywords !== 'undefined') {
                let as_q_val = google_shopify_keywords['as_q'];
                let shopify_country_val = google_shopify_keywords['shopify_country'];
                let shopify_tech_val = google_shopify_keywords['shopify_tech'];

                $('.form-shopify #as_q').val(as_q_val);
                $('.form-shopify #shopify_country').val(shopify_country_val);
                $('.form-shopify #shopify_tech').val(shopify_tech_val);

            }
    });
}
init_search_customer();

function nav(){
    $('.nav-item').click(function (){
        $('.nav-item').removeClass('active');
        $(this).addClass('active');
        if($(this).attr('id') == 'nav-find-website'){
            $('.nav-find-website-content').show();
            $('.nav-batchdig-emails-content').hide();
        }
        if($(this).attr('id') == 'nav-batchdig-emails'){
            $('.nav-find-website-content').hide();
            $('.nav-batchdig-emails-content').show();
        }
    });
}
nav();

function snav(){
    //
    chrome.tabs.getSelected(null, function (tab) { // 先获取当前页面的tabID
        let current_url = tab.url;
        if(current_url){
            let is_sns_search = false;
            let is_shopify_search = false;
            if(current_url.indexOf('facebook.com') != -1){
                is_sns_search = true;
            }else if(current_url.indexOf('twitter.com') != -1) {
                is_sns_search = true;
            }else if(current_url.indexOf('instagram.com') != -1){
                is_sns_search = true;
            }else if(current_url.indexOf('linkedin.com') != -1){
                is_sns_search = true;
            }else if(current_url.indexOf('youtube.com') != -1){
                is_sns_search = true;
            }else if(current_url.indexOf('pinterest.com') != -1){
                is_sns_search = true;
            }else if(current_url.indexOf('tiktok.com') != -1){
                is_sns_search = true;
            }else if(current_url.indexOf('reddit.com') != -1){
                is_sns_search = true;
            }else if(current_url.indexOf('vk.ru') != -1){
                is_sns_search = true;
            }else if(current_url.indexOf('vk.com') != -1){
                is_sns_search = true;
            }else if(current_url.indexOf('ok.ru') != -1){
                is_sns_search = true;
            }
            if(current_url.indexOf('collections') != -1){
                is_shopify_search = true;
            }
            if(is_sns_search){
                 $('.snav-item').removeClass('active');
                 $('#snav-sns').addClass('active');
                 $('.snav-google-content').hide();
                 $('.snav-shopify-content').hide();
                 $('.snav-sns-content').show();
            }
            //
            if(is_shopify_search){
                 $('.snav-item').removeClass('active');
                 $('#snav-shopify').addClass('active');
                 $('.snav-google-content').hide();
                 $('.snav-shopify-content').show();
                 $('.snav-sns-content').hide();
            }
            //
        }
    });
    //
    $('.snav-item').click(function (){
        $('.snav-item').removeClass('active');
        $(this).addClass('active');
        if($(this).attr('id') == 'snav-google'){
            $('.snav-google-content').show();
            $('.snav-sns-content').hide();
            $('.snav-shopify-content').hide();
        }
        if($(this).attr('id') == 'snav-sns'){
             $('.snav-google-content').hide();
             $('.snav-sns-content').show();
             $('.snav-shopify-content').hide();
        }
        if($(this).attr('id') == 'snav-shopify'){
             $('.snav-google-content').hide();
             $('.snav-sns-content').hide();
             $('.snav-shopify-content').show();
        }
    });
}
snav();

//
function init(){
    if(IS_TIEPAI){
        $('.footer').remove();
        $('.tiepai_footer').show();
        $('.collecton-keyword').remove();
    }else{
        $('.footer').show();
        $('.tiepai_footer').remove();
    }
}
init();
//从content接收信息
chrome.runtime.onMessage.addListener((req, send, sendRes) => {
    console.log("收到info:", req.info)
    console.log("收到action:", req.action)
    console.log("收到tbm_map_urls:", req.maijia_num)

    if(req.action == 'background-tips'){
        //
        $('#message-info').html("<div style='color:red'>"+req.info+"</div>");
        //
    }

    sendRes("popup已经收到")

  })