// background.js
console.log('我是后台js...');
//
function util_isnumber(val){
    var regPos = /^[0-9]+.?[0-9]*/; //判断是否是数字。
    if(regPos.test(val) ){
        return true;
    }else{
        return false;
    }
}

function extractEmails (text) {
    return text.match(/([a-zA-Z0-9._-]+@[a-zA-Z0-9._-]+\.[a-zA-Z0-9._-]+)/gi);
}

function util_url_get_domain(url=''){
    url = url.replace('https://','');
    url = url.replace('http://','');
    url = url.replace('www.','');
    urlArr = url.split('/');
    if(urlArr.length>0){
        return urlArr[0];
    }
    return '';
}

function util_url_get_domain_host(url=''){
    domain = util_url_get_domain(url);
    if(domain){
        domainArr = domain.split('.');
        if(domainArr.length>1){
           var domain_may = domainArr[1];
           if(domain_may.length>=5){
               return domain_may;
           }else{
               return domainArr[0];
           }
        }else if(domainArr.length==1){
            return domainArr[0];
        }
    }
    return '';
}

function util_domains_set_from_html(domain_id, html_data='',
                                    q=1, need_urls=[],
                                    is_check_domain_yizhi=true){
    console.log('util_domains_set_from_html');
    //console.log(html_data);
    var emails = [];
    var phone ='';
    var whatsapp = '';
    if(html_data){
        var forbidden_keys = ['1.8.1','.cart', '.index', '.collection',
            '.js', 'template.404','tel:', 'mailto:', '.jpg', '.pdf', '.doc',
            '.xls', '.xlsx', '.png', '.jpeg', '.webp', '.gif', 'javascript:',
            'skype', '#', 'None', '.svg', 'desktop.ts', 'example', 'css', '.studio', 'image', 'jquery', 'swiper', 'myshopline.com',
            'img_', 'xxx.xxx', 'foundation-sites', 'exemple@mail.com', 'exemple@gmail.be', 'exemple@mail.ch', 'john@email.com',
            'your.email@address.com', 'stores@domain.com', 'test@email.com', 'first.last@company.com', 'you@email.com', 'your-email@shopify.com',
            'ada@ada.lt', 'johndoe@domain.com', 'your@email.com', 'jane.smith@email.com', 'abc@xyz.com', 'user@domain.com', 'template.account@template.blog',
            'john@test.com', 'emily@test.com', 'email@domain.com', 'yourname@email.com', 'jill@mail.com', 'joebloggs@email.com', 'abc@abc.abc', 'support@domain.com', 'yellow@hello.com'];
        emails = extractEmails(html_data);
        console.log('emails');
        console.log(emails);
        //
        var $html = $(html_data);
        $html.find('a').each(function (){
            let _a_href = $(this).attr('href');
            if(_a_href){
                //
                if(_a_href.indexOf('t.me') != -1 || _a_href.indexOf('whatsapp') != -1){
                    let _a_href_arr = _a_href.split('phone=');
                    whatsapp = _a_href_arr[_a_href_arr.length-1];
                }else if(_a_href.indexOf('tel:') != -1){
                    _a_href = _a_href.replace('tel:','');
                    phone = _a_href;
                }
            }
        });
        //
    }

    domains_get(function (callback_data) {
        domains = callback_data['domains'];
        //
        var domain_emails = [];
        if(emails && emails.length>0){
            for(j=0;j<emails.length;j++){
                var current_email = emails[j];
                current_email = current_email.toLowerCase().trim();
                //把字符串最后一个.移除掉
                if(current_email[current_email.length-1] == '.'){
                    current_email = current_email.slice(0,-1);
                }
                //排除有些如 .png
                var is_forbidden = false;
                for(k=0;k<forbidden_keys.length;k++){
                    if(current_email.indexOf(forbidden_keys[k])!=-1){
                        is_forbidden = true;
                        break;
                    }
                }
                //leaflet@1.8.0
                let current_email_arr = current_email.split('@');
                if(current_email_arr.length > 1){
                    let current_a_houzhui = current_email_arr[1];
                    let current_a_houzhui_arr = current_a_houzhui.split('.');
                    let is_num_shuliang = 0;
                    for(let k=0;k<current_a_houzhui_arr.length;k++){
                        if(util_isnumber(current_a_houzhui_arr[k])){
                            is_num_shuliang +=1;
                        }
                    }
                    if(is_num_shuliang >=2){
                        is_forbidden = true;
                    }
                }
                //如果长度大于50
                if(current_email.length > 50){
                    is_forbidden = true;
                }
                //
                if(is_check_domain_yizhi){
                    console.log('is_check_domain_yizhi aa');
                    let _domain = domains[domain_id]['d'];
                    _domain = _domain.replace('https://', '');
                    _domain = _domain.replace('http://', '');
                    _domain = _domain.replace('www.', '');
                    _domain = _domain.replace('/', '');
                    console.log('_domain:'+_domain);
                    let current_email_arr = current_email.split('@');
                    console.log('current_email_arr:'+current_email_arr);
                    if(current_email_arr.length > 1 && _domain != current_email_arr[1]){
                        is_forbidden = true;
                    }
                }else{
                    console.log('is_check_domain_yizhi bb');
                }
                //
                //
                if(!is_forbidden && !domain_emails.includes(current_email)){
                    domain_emails.push(current_email);
                }
                //
            }
        }
        if(phone){
            if(!domain_emails.includes('tel:'+phone)){
                domain_emails.push('tel:'+phone);
            }
        }

        if(whatsapp){
            if(!domain_emails.includes('whatsapp:'+whatsapp)){
                domain_emails.push('whatsapp:'+whatsapp);
            }
        }
        domain_email_set(domains[domain_id]['d'], q, domain_emails, function (){
            if(need_urls.length>0){
                let _q = 2;
                for(v=0;v<need_urls.length;v++){
                    //yandex不能使用fetch，会301
                    if(need_urls[v].indexOf('yandex') != -1){
                        spider_ajax_request(domain_id, need_urls[v], _q);
                    }else{
                        spider_request_fetch(domain_id, need_urls[v], _q);
                    }
                    _q++;
                }
            }
        });
        //
    });
    console.log('util_domains_set_from_html end');
}

function spider_domain(domain_id, url){
    console.log('spider domain:'+url);
    $.ajax({
        url:url,
        data: {},
        type: 'GET',
        async:true,
        dataType: 'html',
        contentType:'text/html; charset=utf-8',
        crossDomain: true,
        cache: false,
        success: function(data) {
            console.log('spider_ajax_request_homepage complete');
            if(data){
                //
                    var $html = $(data);
                    //针对单个url可货站的urls搜索
                    //index、contact、about、privacy,policy,terms,conditions,faq,return,refund,shipping,whatsapp
                    //https://www.bing.com/search?q=inbody%3A%40donmily.com&ensearch=1
                    //https://cn.bing.com/search?q=inbody%3A%40donmily.com&ensearch=1
                    //http://124.71.24.32:3039/api/center/plugin/email/database/query?emailDomain=unice.com
                    //https://www.google.com.jm/search?q=intext%3A%40unice.com
                    //https://www.google.co.in/search?q=intext%3A%40costway.com#ip=1
                    //
                    var url_domain = util_url_get_domain(url);
                    var need_urls = [];
                    var need_cha_urls = ['contact', 'about', 'privacy',
                        'policy', 'terms', 'conditions', 'faq', 'return',
                        'refund', 'shipping', 'whatsapp', 'safety', 'quality',
                        'guide', 'service', 'affiliate', 'shippment', 'brand',
                        'followus'];
                    var domain_host = util_url_get_domain_host(url);
                    $html.find('a').each(function (){
                        var temp_href = $(this).attr('href');
                        if(typeof temp_href !== 'undefined'){
                            if(temp_href.indexOf('http')==-1){
                                if(temp_href.indexOf('/')!=-1){
                                    temp_href = url+temp_href;
                                }else{
                                    temp_href = url+'/'+temp_href;
                                }
                            }
                            for(i=0; i<need_cha_urls.length;i++){
                                if(temp_href.indexOf(need_cha_urls[i])!=-1 && temp_href.indexOf(domain_host)!=-1){
                                    if(!need_urls.includes(temp_href)){
                                        need_urls.push(temp_href);
                                    }
                                }
                            }
                        }
                        //
                    });
                    var googles_url = [
                        'https://www.google.com/', //美国
                        'https://www.google.ca/', //加拿大
                        'https://www.google.cd/', //民主刚果
                        'https://www.google.cg/', //刚果
                        'https://www.google.ch/', //瑞士
                        'https://www.google.ci/', //Cote D’Ivoire
                        'https://www.google.co.ck/', //库克
                        'https://www.google.cl/', //智利
                        'https://www.google.com.co/', //哥伦比
                        'https://www.google.co.cr/', //哥斯达尼加
                        'https://www.google.com.cu/', //古
                        'https://www.google.cz/', //捷克
                        'https://www.google.de/', //德国
                        'https://www.google.dj/', //吉布提
                        'https://www.google.dk/', //丹麦
                        'https://www.google.dm/', //多米尼加联邦
                        'https://www.google.com.do/', //多米尼加共和
                        'https://www.google.com.ec/', //厄瓜多
                        'https://www.google.ee/', //爱沙尼亚
                        'https://www.google.com.eg/', //埃
                        'https://www.google.es/', //西班牙
                        'https://www.google.com.et/', //埃塞俄比
                        'https://www.google.com.fj/', //斐
                        'https://www.google.fm/', //密克罗尼西亚
                        'https://www.google.fr/', //法国
                        'https://www.google.ge/', //格鲁吉亚
                        'https://www.google.gg/', //Guernsey
                        'https://www.google.com.gi/', //Gibraltar
                        'https://www.google.gl/', //格陵兰
                        'https://www.google.gm/',//冈比亚
                        'https://www.google.gp/', //爪德罗普岛
                        'https://www.google.gr/', //希腊
                        'https://www.google.com.gt/', //危地马
                        'https://www.google.gy/', //圭亚那
                        'https://www.google.com.hk/', //香港
                        'https://www.google.hr/', //克罗地亚
                        'https://www.google.ht/', //海地
                        'https://www.google.hu/', //匈牙利
                        'https://www.google.co.id/', //印度尼西亚
                        'https://www.google.ie/', //爱尔兰
                        'https://www.google.co.il/', //以色列
                        'https://www.google.im/', //马恩岛
                        'https://www.google.co.in/', //印度
                        'https://www.google.is/', //冰岛
                        'https://www.google.it/', //意大利
                        'https://www.google.je/', //泽西岛
                        'https://www.google.com.jm/', //牙买
                        'https://www.google.jo/', //约旦
                        'https://www.google.co.jp/', //日本
                        'https://www.google.co.ke/', //肯尼亚
                        'https://www.google.com.kh/', //柬埔
                        'https://www.google.ki/', //基里巴斯
                        'https://www.google.kg/', //吉尔吉斯斯坦
                        'https://www.google.co.kr/', //韩国
                        'https://www.google.kz/', //哈萨克斯坦
                        'https://www.google.la/', //老挝
                        'https://www.google.li/', //列支敦士登
                        'https://www.google.lk/', //斯里兰卡
                        'https://www.google.co.ls/', //莱索托
                        'https://www.google.lt/', //立陶宛
                        'https://www.google.lu/', //卢森堡
                        'https://www.google.lv/', //拉托维亚
                        'https://www.google.com.ly/', //利比
                        'https://www.google.co.ma/', //摩洛哥
                        'https://www.google.md/', //摩尔多瓦
                        'https://www.google.mn/', //蒙古
                        'https://www.google.ms/', //蒙特塞拉特
                        'https://www.google.com.mt/', //马耳
                        'https://www.google.mu/', //毛里求斯
                        'https://www.google.mv/', //马尔代夫
                        'https://www.google.mw/', //马拉维
                        'https://www.google.com.mx/', //墨西
                        'https://www.google.com.na/', //纳米比
                        'https://www.google.com.nf/', //诺夫克
                        'https://www.google.com.ng/', //尼日尼
                        'https://www.google.com.ni/', //尼加拉
                        'https://www.google.nl/', //荷兰
                        'https://www.google.no/', //挪威
                        'https://www.google.com.np/', //尼泊
                        'https://www.google.nr/', //瑙鲁
                        'https://www.google.nu/', //纽埃岛
                        'https://www.google.co.nz/', //新西兰
                        'https://www.google.com.om/', //阿
                        'https://www.google.com.pa/', //巴拿
                        'https://www.google.com.pe/', //秘
                        'https://www.google.com.ph/', //菲律
                        'https://www.google.com.pk/', //巴基斯
                        'https://www.google.pl/',//波兰
                        'https://www.google.pn/', //皮特克恩岛
                        'https://www.google.com.pr/',//波多黎
                        'https://www.google.pt/', //葡萄牙
                        'https://www.google.com.py/', //巴拉
                        'https://www.google.com.qa/', //卡塔
                        'https://www.google.ro/', //罗马尼亚
                        'https://www.google.ru/', //俄罗斯
                        'https://www.google.rw/', //卢旺达
                        'https://www.google.com.sa/', //沙,
                        'https://www.google.com.sb/', //所罗
                        'https://www.google.sc/', //塞舌尔
                        'https://www.google.se/', //瑞典
                        'https://www.google.com.sg/', //新加
                        'https://www.google.sh/', //圣赫勒拿岛
                        'https://www.google.si/', //斯洛文尼亚
                        'https://www.google.sk/', //斯洛伐克
                        'https://www.google.sn/', //塞内加尔
                        'https://www.google.sm/', //圣马力诺
                        'https://www.google.st/', //圣多美和普林西比
                        'https://www.google.com.sv/', //萨尔瓦
                        'https://www.google.co.th/', //泰国
                        'https://www.google.com.tj/', //塔吉克斯
                        'https://www.google.tk/', //托克劳
                        'https://www.google.tm/', //土库曼
                        'https://www.google.to/', //汤加
                        'https://www.google.tp/', //东帝汶
                        'https://www.google.com.tr/', //土耳
                        'https://www.google.tt/', //特立尼和多巴哥
                        'https://www.google.com.tw/', //台
                        'https://www.google.com.ua/', //乌克
                        'https://www.google.co.ug/', //乌干达
                        'https://www.google.co.uk/', //英国
                        'https://www.google.com.uy/', //乌拉
                        'https://www.google.co.uz/', //Uzbekistan
                        'https://www.google.com.vc/', //圣文森特和格林纳丁
                        'https://www.google.co.ve/', //委内瑞拉
                        'https://www.google.vg/', //维京岛
                        'https://www.google.co.vi/', //维尔京群岛
                        'https://www.google.com.vn/', //越南
                        'https://www.google.vu/', //瓦努尔图
                        'https://www.google.ws/', //西萨摩亚
                        'https://www.google.co.yu/', //南斯拉夫
                        'https://www.google.co.za/', //南非
                        'https://www.google.co.zm/', //赞比亚
                        'https://www.google.co.zw/', //津巴布韦
                    ];
                    //随机从数组中获取一个值
                    var google_url = googles_url[Math.floor((Math.random()*googles_url.length))];
                    need_urls.push(google_url+'search?q='+url_domain+'+email+OR+E-mail+OR+mail+OR+maito+OR+contact+-inurl:(zoominfo|dnb|rocketreach|signalhire|easyleadz|contactout|apollo|verifier|getemail|aeroleads|datanyze)&ie=utf-8&&num=50&oe=utf-8');
                    //
                     need_urls.push('https://search.yahoo.com/search?p=intext:'+url_domain+'&fr2=sb-top&fr=yfp-t&fp=1');
                    //
                    need_urls.push('https://search.aol.com/aol/search?q=intext:'+url_domain+'&s_it=sb-top&v_t=na');
                    //
                    need_urls.push('https://yandex.com/search/?text='+url_domain+'+email&lr=109371');
                    var tq = need_urls.length+1;
                    domain_tq_set(url, tq, function (){
                    //
                        util_domains_set_from_html(domain_id, data, 1, need_urls, false);
                    //
                    });
            }else{
                //
                domain_tq_set(url, 1, function (){
                    //
                    util_domains_set_from_html(domain_id, '', 1);
                    //
                });
                //
            }
        },
        error: function( jqXHR, textStatus, errorThrown ) {
            console.log( 'spider_domain error:'+jqXHR, textStatus, errorThrown );
            //对于访问异常的请求,直接过滤
            //
            domain_tq_set(url, 1, function (){
                util_domains_set_from_html(domain_id, '', 1);
            });
            //
        }
    });
}

function spider_ajax_request(domain_id, url, q){
    console.log('spider_ajax_request:'+url);
    let is_check_domain_yizhi = false;
    if(url.indexOf('yahoo')!=-1 || url.indexOf('yandex') !=-1 || url.indexOf('aol') !=-1){
        is_check_domain_yizhi = true;
    }
    //
    $.ajax({
        url:url,
        data: {},
        type: 'GET',
        async:true,
        dataType: 'html',
        contentType:'text/html; charset=utf-8',
        crossDomain: true,
        cache: false,
        success: function(data) {
            console.log('url:'+url+' success');
            console.log('util_domains_set_from_html');
            util_domains_set_from_html(domain_id, data, q, [],is_check_domain_yizhi);
            console.log('url:'+url+' end');
        },
       error: function( jqXHR, textStatus, errorThrown ) {
            console.log( jqXHR, textStatus, errorThrown );
            //对于访问异常的请求,直接过滤
            util_domains_set_from_html(domain_id, '', q);
        }
    });
}

//返回html
async function fetch_request(url){
     var return_html = '';
     let options = {
         method: 'get',
         headers: {
             'Content-Type':'application/json;charset=utf-8'
         },
         // body: JSON.stringify(res)
     }
     // Fake api for making post requests
    //console.log('fetch_request url:'+url);
    await fetch(url,options)
        .then(res => res.text())
        .then(d => {
            //403错误也是直接到这里了
            console.log('post response:');
            //console.log(d);
            return_html = d;
        }).catch(function (){
            console.log('fetch_request error url:'+url);
            return_html = '';
        })
    return return_html;
}

function spider_domain_fetch(domain_id, url){
    console.log('spider_domain_fetch domain:'+url);
    //
    let return_html = fetch_request(url);
    return_html.then((data) => {
        if(data){
            //
            var $html = $(data);
            //针对单个url可货站的urls搜索
            //index、contact、about、privacy,policy,terms,conditions,faq,return,refund,shipping,whatsapp
            //https://www.bing.com/search?q=inbody%3A%40donmily.com&ensearch=1
            //https://cn.bing.com/search?q=inbody%3A%40donmily.com&ensearch=1
            //http://124.71.24.32:3039/api/center/plugin/email/database/query?emailDomain=unice.com
            //https://www.google.com.jm/search?q=intext%3A%40unice.com
            //https://www.google.co.in/search?q=intext%3A%40costway.com#ip=1
            //
            var url_domain = util_url_get_domain(url);
            var need_urls = [];
            var need_cha_urls = ['contact', 'about', 'privacy',
                        'policy', 'terms', 'conditions', 'faq', 'return',
                        'refund', 'shipping', 'whatsapp', 'safety', 'quality',
                        'guide', 'service', 'affiliate', 'shippment', 'brand',
                        'followus'];
            var domain_host = util_url_get_domain_host(url);
            $html.find('a').each(function (){
                var temp_href = $(this).attr('href');
                if(typeof temp_href !== 'undefined'){
                    if(temp_href.indexOf('http')==-1){
                        if(temp_href.indexOf('/')!=-1){
                            temp_href = url+temp_href;
                        }else{
                                   temp_href = url+'/'+temp_href;
                        }
                    }
                    for(i=0; i<need_cha_urls.length;i++){
                        if(temp_href.indexOf(need_cha_urls[i])!=-1 && temp_href.indexOf(domain_host)!=-1){
                            if(!need_urls.includes(temp_href)){
                                need_urls.push(temp_href);
                            }
                        }
                    }
                }
            });
            var googles_url = [
                        'https://www.google.com/', //美国
                        'https://www.google.ca/', //加拿大
                        'https://www.google.cd/', //民主刚果
                        'https://www.google.cg/', //刚果
                        'https://www.google.ch/', //瑞士
                        'https://www.google.ci/', //Cote D’Ivoire
                        'https://www.google.co.ck/', //库克
                        'https://www.google.cl/', //智利
                        'https://www.google.com.co/', //哥伦比
                        'https://www.google.co.cr/', //哥斯达尼加
                        'https://www.google.com.cu/', //古
                        'https://www.google.cz/', //捷克
                        'https://www.google.de/', //德国
                        'https://www.google.dj/', //吉布提
                        'https://www.google.dk/', //丹麦
                        'https://www.google.dm/', //多米尼加联邦
                        'https://www.google.com.do/', //多米尼加共和
                        'https://www.google.com.ec/', //厄瓜多
                        'https://www.google.ee/', //爱沙尼亚
                        'https://www.google.com.eg/', //埃
                        'https://www.google.es/', //西班牙
                        'https://www.google.com.et/', //埃塞俄比
                        'https://www.google.com.fj/', //斐
                        'https://www.google.fm/', //密克罗尼西亚
                        'https://www.google.fr/', //法国
                        'https://www.google.ge/', //格鲁吉亚
                        'https://www.google.gg/', //Guernsey
                        'https://www.google.com.gi/', //Gibraltar
                        'https://www.google.gl/', //格陵兰
                        'https://www.google.gm/',//冈比亚
                        'https://www.google.gp/', //爪德罗普岛
                        'https://www.google.gr/', //希腊
                        'https://www.google.com.gt/', //危地马
                        'https://www.google.gy/', //圭亚那
                        'https://www.google.com.hk/', //香港
                        'https://www.google.hr/', //克罗地亚
                        'https://www.google.ht/', //海地
                        'https://www.google.hu/', //匈牙利
                        'https://www.google.co.id/', //印度尼西亚
                        'https://www.google.ie/', //爱尔兰
                        'https://www.google.co.il/', //以色列
                        'https://www.google.im/', //马恩岛
                        'https://www.google.co.in/', //印度
                        'https://www.google.is/', //冰岛
                        'https://www.google.it/', //意大利
                        'https://www.google.je/', //泽西岛
                        'https://www.google.com.jm/', //牙买
                        'https://www.google.jo/', //约旦
                        'https://www.google.co.jp/', //日本
                        'https://www.google.co.ke/', //肯尼亚
                        'https://www.google.com.kh/', //柬埔
                        'https://www.google.ki/', //基里巴斯
                        'https://www.google.kg/', //吉尔吉斯斯坦
                        'https://www.google.co.kr/', //韩国
                        'https://www.google.kz/', //哈萨克斯坦
                        'https://www.google.la/', //老挝
                        'https://www.google.li/', //列支敦士登
                        'https://www.google.lk/', //斯里兰卡
                        'https://www.google.co.ls/', //莱索托
                        'https://www.google.lt/', //立陶宛
                        'https://www.google.lu/', //卢森堡
                        'https://www.google.lv/', //拉托维亚
                        'https://www.google.com.ly/', //利比
                        'https://www.google.co.ma/', //摩洛哥
                        'https://www.google.md/', //摩尔多瓦
                        'https://www.google.mn/', //蒙古
                        'https://www.google.ms/', //蒙特塞拉特
                        'https://www.google.com.mt/', //马耳
                        'https://www.google.mu/', //毛里求斯
                        'https://www.google.mv/', //马尔代夫
                        'https://www.google.mw/', //马拉维
                        'https://www.google.com.mx/', //墨西
                        'https://www.google.com.na/', //纳米比
                        'https://www.google.com.nf/', //诺夫克
                        'https://www.google.com.ng/', //尼日尼
                        'https://www.google.com.ni/', //尼加拉
                        'https://www.google.nl/', //荷兰
                        'https://www.google.no/', //挪威
                        'https://www.google.com.np/', //尼泊
                        'https://www.google.nr/', //瑙鲁
                        'https://www.google.nu/', //纽埃岛
                        'https://www.google.co.nz/', //新西兰
                        'https://www.google.com.om/', //阿
                        'https://www.google.com.pa/', //巴拿
                        'https://www.google.com.pe/', //秘
                        'https://www.google.com.ph/', //菲律
                        'https://www.google.com.pk/', //巴基斯
                        'https://www.google.pl/',//波兰
                        'https://www.google.pn/', //皮特克恩岛
                        'https://www.google.com.pr/',//波多黎
                        'https://www.google.pt/', //葡萄牙
                        'https://www.google.com.py/', //巴拉
                        'https://www.google.com.qa/', //卡塔
                        'https://www.google.ro/', //罗马尼亚
                        'https://www.google.ru/', //俄罗斯
                        'https://www.google.rw/', //卢旺达
                        'https://www.google.com.sa/', //沙,
                        'https://www.google.com.sb/', //所罗
                        'https://www.google.sc/', //塞舌尔
                        'https://www.google.se/', //瑞典
                        'https://www.google.com.sg/', //新加
                        'https://www.google.sh/', //圣赫勒拿岛
                        'https://www.google.si/', //斯洛文尼亚
                        'https://www.google.sk/', //斯洛伐克
                        'https://www.google.sn/', //塞内加尔
                        'https://www.google.sm/', //圣马力诺
                        'https://www.google.st/', //圣多美和普林西比
                        'https://www.google.com.sv/', //萨尔瓦
                        'https://www.google.co.th/', //泰国
                        'https://www.google.com.tj/', //塔吉克斯
                        'https://www.google.tk/', //托克劳
                        'https://www.google.tm/', //土库曼
                        'https://www.google.to/', //汤加
                        'https://www.google.tp/', //东帝汶
                        'https://www.google.com.tr/', //土耳
                        'https://www.google.tt/', //特立尼和多巴哥
                        'https://www.google.com.tw/', //台
                        'https://www.google.com.ua/', //乌克
                        'https://www.google.co.ug/', //乌干达
                        'https://www.google.co.uk/', //英国
                        'https://www.google.com.uy/', //乌拉
                        'https://www.google.co.uz/', //Uzbekistan
                        'https://www.google.com.vc/', //圣文森特和格林纳丁
                        'https://www.google.co.ve/', //委内瑞拉
                        'https://www.google.vg/', //维京岛
                        'https://www.google.co.vi/', //维尔京群岛
                        'https://www.google.com.vn/', //越南
                        'https://www.google.vu/', //瓦努尔图
                        'https://www.google.ws/', //西萨摩亚
                        'https://www.google.co.yu/', //南斯拉夫
                        'https://www.google.co.za/', //南非
                        'https://www.google.co.zm/', //赞比亚
                        'https://www.google.co.zw/', //津巴布韦
                    ];
            //随机从数组中获取一个值
            var google_url = googles_url[Math.floor((Math.random()*googles_url.length))];
            need_urls.push(google_url+'search?q='+url_domain+'+email+OR+E-mail+OR+mail+OR+maito+OR+contact+-inurl:(zoominfo|dnb|rocketreach|signalhire|easyleadz|contactout|apollo|verifier|getemail|aeroleads|datanyze)&ie=utf-8&&num=50&oe=utf-8');
            //
            need_urls.push('https://search.yahoo.com/search?p=intext:'+url_domain+'&fr2=sb-top&fr=yfp-t&fp=1');
            //
            need_urls.push('https://search.aol.com/aol/search?q=intext:'+url_domain+'&s_it=sb-top&v_t=na');
            //
            need_urls.push('https://yandex.com/search/?text='+url_domain+'+email&lr=109371');
            var tq = need_urls.length+1;
            domain_tq_set(url, tq, function (){
                //
                util_domains_set_from_html(domain_id, data, 1, need_urls, false);
                //
            });
        }else{
            //
            domain_tq_set(url, 1, function (){
                //
                util_domains_set_from_html(domain_id, '', 1);
                //
            });
            //
        }
    });
}

function spider_request_fetch(domain_id, url, q){
    console.log('spider_request_fetch:'+url);
    let is_check_domain_yizhi = false;
    if(url.indexOf('google')!=-1 || url.indexOf('yahoo')!=-1 || url.indexOf('yandex') !=-1 || url.indexOf('aol') !=-1){
        is_check_domain_yizhi = true;
    }
    let return_html = fetch_request(url);
    return_html.then((data) => {
        if(data){
            util_domains_set_from_html(domain_id, data, q,[],is_check_domain_yizhi);
        }else{
            //对于访问异常的请求,直接过滤
            util_domains_set_from_html(domain_id, '', q,[],is_check_domain_yizhi);
        }
    });
}

//监听
chrome.storage.onChanged.addListener(function(changes, namespace) {
    for (var key in changes) {
          var storageChange = changes[key];
          console.log('Storage key "%s" in namespace "%s" changed. ' +
                      'Old value was "%s", new value is "%s".',
                      key,
                      namespace,
                      storageChange.oldValue,
                      storageChange.newValue);
          /*if(key=='domains'){
              var max_bingf = 5;
              var newdomains = storageChange.newValue;
              if(typeof newdomains === 'undefined'){
                  newdomains = storageChange.oldValue;
              }
              console.log('newdomains');
              console.log(newdomains);
              //判断s=1是否有5个，如果有则跳过，如果没有则继续,用来执行同时爬取的网址数
              var s_status_1 = 0;
              for(i=0; i<newdomains.length; i++){
                  if(newdomains[i]['s'] == 1){
                      s_status_1 +=1;
                  }
              }
              if(s_status_1<max_bingf){
                  for(i=0; i<newdomains.length; i++){
                        if(newdomains[i]['s'] == 0){
                            newdomains[i]['s'] = 1;
                            s_status_1 +=1
                            console.log('domain:'+newdomains[i]['d']);
                            spider_domain(i, newdomains[i]['d']);
                            if(s_status_1>=max_bingf){
                                break;
                            }
                        }
                  }
                  //
                  domains_set(newdomains);
                  //
              }
              //
          }*/
    }
    //
    chrome.storage.local.get(null, function(items) {
        console.log('items');
        //console.log(items);
    });
    //
 });

function domain_email_set(domain, q=1, emails=[], callback){
    /*chrome.storage.local.set({domains: values}, () => {
        console.log('set successed!');
    });*/
    //q为当前请求第几个，domain
    let prefix = 'dqe_'+$.md5(domain)+"_"+q;
    let obj = {};
    obj[prefix] = emails;
    /*chrome.storage.local.set(obj, () => {
        console.log('domainqemails_:'+domain+' set success');
    });*/
    chrome.storage.local.set(obj, callback);
}

function domain_tq_set(domain, tq=0, callback){
    let prefix = 'dtq_'+$.md5(domain);
    let obj = {};
    obj[prefix] = tq;
    /*chrome.storage.local.set(obj, () => {
        console.log('domain:'+domain+' set success');
    });*/
    chrome.storage.local.set(obj, callback);
}

function domains_set_callback(values, callback){
    /*chrome.storage.sync.set({domains: values}, () => {
        console.log('set successed!');
    });*/
    chrome.storage.local.set({domains: values}, callback);
}

function domains_set(values){
    /*chrome.storage.local.set({domains: values}, () => {
        console.log('set successed!');
    });*/
    chrome.storage.local.set({domains: values}, () => {
        console.log('set successed!');
    });
}

function domains_get(callback){
     /*chrome.storage.sync.get('domains', (res) => {
        console.log(res);
        return res;
     });*/
    chrome.storage.local.get('domains', callback);
}

function domains_remove(){
    chrome.storage.local.remove(["domains","key2"],function(){
        var error = chrome.runtime.lastError;
        if (error){console.error(error);}
        else{
            console.log('domains is clean')
        }
    })
}

function domains_remove_keys(keys = []){
    chrome.storage.local.remove(keys,function(){
        var error = chrome.runtime.lastError;
        if (error){console.error(error);}
        else{
            console.log('domains '+keys.join('-')+' has remove');
        }
    })
}

function domains_clear(){
    plugin_get_expire(function (callback_data){
        let expire_date = callback_data['expire'];
        if(typeof expire_date != 'undefined'){
            chrome.storage.local.clear(function(){
                console.log('remove all');
                plugin_set_expire(expire_date);
            })
        }else{
            chrome.storage.local.clear(function(){
                console.log('remove all');
            })
        }
    });

}

function domains_get_data_process(){
    chrome.storage.local.get(null, function(items) {
        console.log('items');
        //console.log(items);
        //
        let domains = items['domains'];
        if(typeof domains != 'undefined') {
            for(i=0; i<domains.length; i++){
                var _domain = domains[i]['d'];
                //
                var _domain_s = domains[i]['s'];
                if(_domain_s==1){
                    var _domain_dtq_key = 'dtq_'+$.md5(_domain);
                    var _domain_dtq_num = items[_domain_dtq_key];
                    var _domain_dqe_key = 'dqe_'+$.md5(_domain)+'_';
                    var _domain_dqe_num  = 0;
                    for (let _key in items) {
                        //console.log('_key:'+_key);
                        if(_key.indexOf(_domain_dqe_key)!=-1){
                            _domain_dqe_num +=1;
                        }
                    }
                    if(_domain_dtq_num == _domain_dqe_num){
                        _domain_s = 2;
                    }
                    if(_domain_s == 2){
                        domains[i]['s'] = 2;
                    }
                    if(_domain_s == 2){
                        //邮箱处理
                        var emails = [];
                        for (let _key in items) {
                            if(_key.indexOf(_domain_dqe_key)!=-1){
                                var _emails = items[_key];
                                if(_emails.length>0){
                                    for(let e=0;e<_emails.length;e++){
                                        if(!emails.includes(_emails[e])){
                                            emails.push(_emails[e]);
                                        }
                                    }
                                }
                            }
                        }
                        //
                         domains[i]['e'] = emails;
                        //
                    }
                    //移除dtq,dqe
                    if(_domain_s == 2){
                        let remove_keys = [];
                        remove_keys.push(_domain_dtq_key);
                        for (let _key in items) {
                            if(_key.indexOf(_domain_dqe_key)!=-1){
                               remove_keys.push(_key);
                            }
                        }
                        //
                        domains_remove_keys(remove_keys);
                        //
                    }
                    //
                }
            }
            //
            domains_set(domains);
            //
        }

    });
}

function xintiao(){
    domains_get(function (callback_data) {
        newdomains = callback_data['domains'];
        //
        var max_bingf = 5;
        console.log('newdomains');
        //console.log(newdomains);
        //判断s=1是否有5个，如果有则跳过，如果没有则继续,用来执行同时爬取的网址数
        if(typeof newdomains != 'undefined') {
            var s_status_1 = 0;
            for (i = 0; i < newdomains.length; i++) {
                if (newdomains[i]['s'] == 0) {
                    newdomains[i]['s'] = 1;
                    s_status_1 += 1
                    console.log('domain:' + newdomains[i]['d']);
                    //spider_domain(i, newdomains[i]['d']);
                    spider_domain_fetch(i, newdomains[i]['d']);
                    if (s_status_1 >= max_bingf) {
                        break;
                    }
                }
            }
            //
            if (s_status_1 > 0) {
                domains_set(newdomains);
            }
        }
        //
    });
}
xintiao();
setInterval(xintiao, 10000);

function plugin_set_expire(expire,callback){
    chrome.storage.local.set({expire: expire}, callback);
}

function plugin_get_expire(callback){
    chrome.storage.local.get('expire', callback);
}

function google_keyword_set(values, callback){
    chrome.storage.local.set({google_keywords: values},callback);
}

function google_keyword_get(callback){
    chrome.storage.local.get('google_keywords', callback);
}

function google_sns_keyword_set(values, callback){
    chrome.storage.local.set({google_sns_keywords: values}, callback);
}

function google_sns_keyword_get(callback){
    chrome.storage.local.get('google_sns_keywords', callback);
}

function google_shopify_keyword_set(values, callback){
    chrome.storage.local.set({google_shopify_keywords: values}, callback);
}

function google_shopify_keyword_get(callback){
    chrome.storage.local.get('google_shopify_keywords', callback);
}

function test()
{
	alert('我是background！');
}

/**
 * 1.
 * chrome.runtime.onInstalled.addListener(details => {
  console.log('previousVersion', details.previousVersion);
});
2.
 //发送消息
 chrome.runtime.sendMessage({
        action: 'send',
        keyword: 'keyword value'
      }, function (response) {   //接收回调
        console.log(response);  //{state:'关键词填写成功！'}
      });

//监听扩展程序进程或内容脚本发送请求的请求
chrome.runtime.onMessage.addListener(
  function (request, sender, sendResponse) {
    if (request.action == 'send') {
      console.log('action',request,sender,sendResponse);
//  request {action: "send", keyword: "keyword value"}
 //sender  {id: "agkllkkjbhclhjnlebdbdagkagfgcecj", url: "chrome-extension://agkllkkjbhclhjnlebdbdagkagfgcecj/popup.html", origin: "chrome-extension://agkllkkjbhclhjnlebdbdagkagfgcecj"}
//sendResponse  ƒ () { [native code] }
      sendResponse({state:'关键词填写成功！'});
    }
  }
);
 */
function util_url_get_website(arg_url=''){
    // 要匹配的URL
    var url = arg_url;
    // 正则表达式模式，用于匹配协议和主机名
    var pattern = /^(https?):\/\/([^\/]+)(.*)$/;
    // 使用正则表达式进行匹配
    var matches = url.match(pattern);
    if (matches) {
      var protocol = matches[1]; // 协议部分，例如 "http" 或 "https"
      var hostname = matches[2]; // 主机名部分，例如 "www.example.com"

      return protocol+'://'+hostname;
    } else {
      return arg_url;
    }
}

function util_url_get_domain(url=''){
    url = url.replace('https://','');
    url = url.replace('http://','');
    url = url.replace('www.','');
    let urlArr = url.split('/');
    if(urlArr.length>0){
        return urlArr[0];
    }
    return '';
}

function util_checkFanpa(str = ''){
    const searchString = "This item is sold out";
    const regex = new RegExp(searchString);
    const containsString = regex.test(str);
    if(containsString){
        return true;
    } else {
        return false;
    }
}

function util_check_domain_isexists(arr = [], domain=''){
    let is_exists = false;
    for(let j=0;j<arr.length;j++){
        if(arr[j]['domain'] == domain){
            is_exists = true;
            break;
        }
    }
    return is_exists;
}

function pause_switch(callback){
    chrome.storage.local.get(null, function(items) {
        //
        let prefix = 'pause';
        if (!items.hasOwnProperty(prefix)) {
            chrome.storage.local.set({pause: 1}, callback);
        }else{
            if(items[prefix] == 1){
                chrome.storage.local.set({pause: 0}, callback);
            }else{
                chrome.storage.local.set({pause: 1}, callback);
            }
        }
    });
}

function storage_shangjia_about_contact_and_basic_info_set(_shangjia_info={}, callback){
    let prefix = 'shangjia_about_contact_and_basic_info_'+$.md5(_shangjia_info['_shangjia_id']);
    //
    chrome.storage.local.get(null, function(items) {
        //
        if(!items.hasOwnProperty(prefix)){
            let obj = {};
            obj[prefix] = {
                '_shangjia_id': _shangjia_info['_shangjia_id'],
                '_shangjia_name': _shangjia_info['_shangjia_name'],
                '_shangjia_about_contact_and_basic_info_link':_shangjia_info['_shangjia_a_link'],

                '_is_request':0,
                '_search_result': '',
                '_error':''
            };
            chrome.storage.local.set(obj, callback);
        }
        //
    });
    //
}

function request_shangjia_about_contact_and_basic_info_ajax(storage_key=''){
    chrome.storage.local.get(null, function(items) {
        let need_item = items[storage_key];
        //
        $.ajax({
            url:need_item['_shangjia_about_contact_and_basic_info_link'],
            timeout : 5000, //超时时间设置，单位毫秒
            data: {},
            type: 'GET',
            async:true,
            dataType: 'html',
            contentType:'text/html; charset=utf-8',
            crossDomain: true,
            cache: false,
            success: function(data) {
               let _dom = $(data);
               //
               /*let _mainContent = _dom.find('.mainContent').text();
               let _baseContent = _dom.find('.baseContent').text();
               let _checkContent = _mainContent;
               if(_baseContent){
                   _checkContent += _baseContent;
               }*/
                let _search_result = [];
                _dom.find('#rcnt .MjjYud').each(function (){
                    let a_href_val = $(this).find('a').attr('href');
                    let a_domain_val  = util_url_get_domain(a_href_val);
                    let shangjia_info_title = $(this).find('h3').text();
                    let shangjia_info_desc = $(this).find('.VwiC3b').text();
                    if(!shangjia_info_desc){
                        shangjia_info_desc = $(this).find('.mSA5Bd').text();
                    }
                    //video
                    if(!shangjia_info_desc){
                        shangjia_info_desc = $(this).find('.ITZIwc').text();
                    }
                    //
                    //
                    if(util_check_domain_isexists(_search_result,a_domain_val) == false){
                         _search_result.push({
                                                'url': a_href_val,
                                                'website':util_url_get_website(a_href_val),
                                                'domain': a_domain_val,
                                                'title': shangjia_info_title,
                                                'description': shangjia_info_desc
                                            });
                    }
                    //
                });
                //
                //
                need_item['_is_request'] = 2;
                need_item['_e_time'] = Date.now();
                need_item['_search_result'] = _search_result;
                need_item['_error'] = '';
                let obj = {};
                obj[storage_key] = need_item;
                chrome.storage.local.set(obj, function (){
                });
                //
            },
            error: function( jqXHR, textStatus, errorThrown ) {
                console.log( jqXHR, textStatus, errorThrown );
                //
                if(textStatus == 'error'){
                    console.log('jqXhr error:'+jqXHR.responseText);
                    let _dom = $(jqXHR.responseText);
                    let _captcha_form =  _dom.find('#captcha-form');
                    if(_captcha_form){
                       //
                        // 使用正则表达式提取 <title> 标签内容
                        let _verify_url = '';
                        let _titleVal  = '';
                        let _jqXHR_responseText = jqXHR.responseText;
                        let _titleMatch = _jqXHR_responseText.match(/<title>(.*?)<\/title>/i);
                        if (_titleMatch && _titleMatch[1]) {
                          _verify_url = _titleVal = _titleMatch[1];
                        }
                        //
                        need_item['_is_request'] = 0;
                        need_item['_error'] = '遇到反爬,请更换代理或者暂停采集，稍后再采集!或者访问该链接进行人机验证:'+_verify_url;
                        let obj = {};
                        obj[storage_key] = need_item;
                        chrome.storage.local.set(obj, function (){
                                //

                                //
                        });
                        sendPopTips('遇到反爬,请更换代理或者暂停采集，稍后再采集!或者访问该链接进行人机验证:<a href="'+_verify_url+'" target="_blank">访问</a>');
                        //
                   }else{
                        //
                        console.log('jqXhr error2:'+jqXHR.responseText);
                        need_item['_is_request'] = 0;
                        need_item['_error'] = errorThrown;
                        let obj = {};
                        obj[storage_key] = need_item;
                        chrome.storage.local.set(obj, function (){
                                //

                                //
                        });
                        //
                        sendPopTips('遇到反爬,请更换代理或者暂停采集，稍后再采集!'+jqXHR.responseText);
                        //
                    }
                }
                //
            }
        });
        //
    })
}

function request_shangjia_about_contact_and_basic_info(){
    chrome.storage.local.get(null, function(items) {
        //
        let need_item = null;
        for(let key in items){
            if(key.indexOf('shangjia_about_contact_and_basic_info_') > -1){
                if(items[key]['_is_request'] == 0 || (items[key]['_is_request'] == 1 && items[key]['_s_time'] < (Date.now()-10000))){
                    need_item = items[key];
                    need_item['_is_request'] = 1;
                    need_item['_s_time'] = Date.now();
                    let obj = {};
                    obj[key] = need_item;
                    chrome.storage.local.set(obj, function (){
                        //
                        request_shangjia_about_contact_and_basic_info_ajax(key);
                        //
                    });
                    break;
                }
            }
        }
        //
    });
}

function xintiao_find(){
     chrome.storage.local.get(null, function(items) {
         if(!items.hasOwnProperty('pause') || items['pause'] == 0){
             console.log('爬取中');
             request_shangjia_about_contact_and_basic_info();
         }else{
             console.log('已暂停爬取');
         }
    });

    //request_shangjia_about_work_and_education_link();
    //request_shangjia_company_page_link();
    chrome.storage.local.get(null, function(items) {
        console.log('items');
        console.log(items);
    });
    //let str = '';

    //let _dom = $(str);
    //https://www.facebook.com/gabriella.obi.77/about_work_and_education
    //
    //let _shangjia_company_page_link = _dom.find('.x1gan7if span.xvq8zen a.x1a2a7pz.xt0b8zv').attr('href');
    //console.log(_shangjia_company_page_link);

    //let _shangjia_company_page_name = _dom.find('.x1gan7if span.xvq8zen a.x1a2a7pz.xt0b8zv').text();
    //console.log(_shangjia_company_page_name);
}
xintiao_find();
setInterval(xintiao_find, 10000);

//
function storage_clear(){
    /*plugin_get_expire(function (callback_data){
        let expire_date = callback_data['expire'];
        if(typeof expire_date != 'undefined'){
            chrome.storage.local.clear(function(){
                console.log('remove all');
                plugin_set_expire(expire_date);
            })
        }else{
            chrome.storage.local.clear(function(){
                console.log('remove all');
            })
        }
    });*/
    chrome.storage.local.get(null, function(items) {
        //
        let need_item = null;
        for (let key in items) {
            if (key.indexOf('shangjia_about_contact_and_basic_info_') > -1) {
                // 清空特定值
                chrome.storage.local.remove(key, function() {
                   console.log(`键名 ${key} 的值已被清空！`);
                });
            }
            if (key.indexOf('shangjia_about_work_and_education_') > -1) {
                // 清空特定值
                chrome.storage.local.remove(key, function() {
                   console.log(`键名 ${key} 的值已被清空！`);
                });
            }
            if(key == 'shangjias'){
                // 清空特定值
                chrome.storage.local.remove(key, function() {
                   console.log(`键名 ${key} 的值已被清空！`);
                });
            }
        }
    });
}
//
function get_data_process(){

    let total_add_shangjia_num = 0;
    let has_caiji_geren_num = 0;
    let has_caiji_company_num = 0;

    chrome.storage.local.get(null, function(items) {
        //
        for(let key in items){
            if(key.indexOf('shangjia_about_contact_and_basic_info_') > -1){
                total_add_shangjia_num += 1;
                if(items[key]['_is_request'] == 2){
                    has_caiji_geren_num += 1;
                }
            }

        }
        //
        let obj = {};
        obj['data_process'] = {
            'total_add_shangjia_num': total_add_shangjia_num,
            'has_caiji_geren_num': has_caiji_geren_num,
            'has_caiji_company_num': has_caiji_company_num,
        }
        chrome.storage.local.set(obj, function (){
            //
            //
        });
        //
    });
}
//
function data_process_get(callback){
     /*chrome.storage.sync.get('domains', (res) => {
        console.log(res);
        return res;
     });*/
    chrome.storage.local.get('data_process', callback);
}

function storage_shangjias_update(shangjia_infos=[]){
    //console.log('storage_shangjias_update a');
    chrome.storage.local.get('shangjias', function(items) {
        //console.log('storage_shangjias_update b');
        //console.log(items);
        if(!items.hasOwnProperty('shangjias')){
            let obj = {};
            let shangjias = [];
            for(let i=0;i<shangjia_infos.length;i++){
                shangjias.push(shangjia_infos[i]['_shangjia_id']);
            }
            obj['shangjias'] = shangjias;
            chrome.storage.local.set(obj);
        }else{
            let storage_shangjias = items['shangjias'];

            for(let i=0;i<shangjia_infos.length;i++){
                let is_exists = false;
                for(let j=0;j<storage_shangjias.length;j++){
                    if(shangjia_infos[i]['_shangjia_id'] == storage_shangjias[j]){
                        is_exists = true;
                        break;
                    }
                }
                //
                if(!is_exists){
                    storage_shangjias.push(shangjia_infos[i]['_shangjia_id']);
                }
                //
            }
            //
            let obj = {};
            obj['shangjias'] = storage_shangjias;
            chrome.storage.local.set(obj);
            //
        }
    })
}

function sendPopTips(msg = ''){
     console.log('sendPopTips:'+msg);
     chrome.runtime.sendMessage({
        action: 'background-tips',
        info: msg
      }, function (response) {   //接收回调
        console.log(response);  //{state:'关键词填写成功！'}
      });
}

function shangjia_items_update(shangjia_infos = []){
    //
    storage_shangjias_update(shangjia_infos);
    //
    for (let i=0;i<shangjia_infos.length;i++){
        storage_shangjia_about_contact_and_basic_info_set(shangjia_infos[i],function (){
        });
    }
    //

    //

}

function storage_get(callback){
    chrome.storage.local.get(null, callback);
}
//监听扩展程序进程或内容脚本发送请求的请求
chrome.runtime.onMessage.addListener(
  function (request, sender, sendResponse) {
    if (request.action == 'shangjia_items_update') {
        console.log('action',request,sender,sendResponse);
        //
        let shangjia_infos = request.shangjia_infos;
        //
        storage_shangjias_update(shangjia_infos);
        //
        for (let i=0;i<shangjia_infos.length;i++){
            storage_shangjia_about_contact_and_basic_info_set(shangjia_infos[i],function (){

            });
        }
        //
        //request {action: "send", keyword: "keyword value"}
        //sender  {id: "agkllkkjbhclhjnlebdbdagkagfgcecj", url: "chrome-extension://agkllkkjbhclhjnlebdbdagkagfgcecj/popup.html", origin: "chrome-extension://agkllkkjbhclhjnlebdbdagkagfgcecj"}
        //sendResponse  ƒ () { [native code] }
        sendResponse({state:'关键词填写成功！'});
    }
  }
);