function util_get_time(){
    return new Date().getTime() ; // 1622427445085
}

function util_check_expire(expire_date=''){
    if(expire_date==''){
        return true;
    }
    expire_date = expire_date.replace('T00:00:00.000Z','');
    let now_date = new Date();
    expire_date_list = expire_date.split('-');
    expire_date_f = new Date(expire_date_list[0], (expire_date_list[1]-1), expire_date_list[2]);
    if (now_date > expire_date_f) {
        return true;
    }
    return false;
}

function util_url_get_domain(url=''){
    url = url.replace('https://','');
    url = url.replace('http://','');
    url = url.replace('www.','');
    let urlArr = url.split('/');
    if(urlArr.length>0){
        return urlArr[0];
    }
    return '';
}

function util_extract_url(s) {
    //var reg = /(http:\/\/|https:\/\/)((\w|=|\?|\.|\/|&|-)+)/g;
    var reg= /(https?|http|ftp|file):\/\/[-A-Za-z0-9+&@#/%?=~_|!:,.;]+[-A-Za-z0-9+&@#/%=~_|]/g;
    s = s.match(reg);
    console.log(s);
    return(s)
}

function util_getwebsite_url(url = ''){
    let urlString = url;
    let urlPattern = /^(https?:\/\/)?([^\/]+)\/.*/; // 匹配协议和域名部分
    let match = urlString.match(urlPattern);
    if (match) {
      let protocol = match[1] || 'http://'; // 如果没有协议，默认为 http
      let domain = match[2];
      return protocol+domain;
    } else {
      return url;
    }
}

function extract_google_search_export(){
    //
    var shangjia_infos = [];

    var q_name = $("textarea[name='q']").val();
    if(!q_name){
        q_name = $("input[name='q']").val();
    }
    //if(util_check_expire(expire_date)==false) {
        //
        shangjia_infos.push({
            'url': q_name,
            'website':'',
            'domain': window.location.href,
            'title': '',
            'description':''
        })
        //
        let current_url = window.location.href;
        let is_google_yuansheng = true;
        let is_google_images = false;
        let is_google_videos = false;
        let is_google_shopping = false;
        //
        if(current_url){
            if(current_url.indexOf('tbm=isch') != -1){
                is_google_images = true;
                is_google_yuansheng = false;
            }else if(current_url.indexOf('tbm=vid') != -1){
                is_google_videos = true;
                is_google_yuansheng = false;
            }else if(current_url.indexOf('tbm=shop') != -1){
                is_google_shopping = true;
                is_google_yuansheng = false;
            }
        }
        //
        let file_name = 'google-web';
        if(is_google_yuansheng || is_google_videos || is_google_shopping){
            if(is_google_videos){
                q_name = 'videos-'+q_name;
                file_name = 'google-videos';
            }else if(is_google_shopping){
                q_name = 'shopping-'+q_name;
                file_name = 'google-shopping';
            }
            //
            var shangjia_infos_localStorage = [];
            if(localStorage.getItem("shangjia_infos_localStorage") == null){
                localStorage['shangjia_infos_localStorage'] = JSON.stringify([]);
            }
            shangjia_infos_localStorage = JSON.parse(localStorage['shangjia_infos_localStorage']);
            for(let f=0;f<shangjia_infos_localStorage.length;f++){
                shangjia_infos.push(shangjia_infos_localStorage[f]);
            }
            //
            search_localStorage_clean();
            //
        }else if(is_google_images){
            q_name = 'images-'+q_name;
            file_name = 'google-images';
            let tj = 0;
            $('#islrg div.isv-r.PNCib').each(function (){
                tj = tj +1 ;
                console.log('tj:'+tj);
                let a_href_val = $(this).find('a:last-child').attr('href');
                let a_domain_val  = util_url_get_domain(a_href_val);
                let keyword_name = $(this).find('h3').text();
                //
                let is_exists = false;
                for(j=0;j<shangjia_infos.length;j++){
                    if(shangjia_infos[j]['domain'] == a_domain_val){
                        is_exists = true;
                        break;
                    }
                }
                //
                if(is_exists == false){
                    shangjia_infos.push({
                        'url':a_href_val,
                        'website': util_getwebsite_url(a_href_val),
                        'domain': a_domain_val,
                        'title': keyword_name,
                        'description':'',
                    });
                }
                //
            });
        }

    //}
     var catalog_products = {
         'shangjia_infos': shangjia_infos,
         'file_name': file_name+'-'+util_get_time(),
         'expire':get_expire()
     }

     return catalog_products;
}

function extract_sns_export(){
    //
    var shangjia_infos = [];

    var q_name = $("textarea[name='q']").val();

    var expire_data = get_expire();
    var expire_date_dict = expire_data[0];
    var expire_date = expire_date_dict['expire'];
    //if(util_check_expire(expire_date)==false) {
        //
        shangjia_infos.push({
            'url': q_name,
            'website':'',
            'domain': window.location.href,
            'title': '',
            'description':''
        })
        //
        var shangjia_infos_localStorage = [];
        if(localStorage.getItem("shangjia_infos_localStorage") == null){
            localStorage['shangjia_infos_localStorage'] = JSON.stringify([]);
        }
        shangjia_infos_localStorage = JSON.parse(localStorage['shangjia_infos_localStorage']);
        for(let f=0;f<shangjia_infos_localStorage.length;f++){
            shangjia_infos.push(shangjia_infos_localStorage[f]);
        }
        //
        search_localStorage_clean();
        //
    //}
     var catalog_products = {
         'shangjia_infos': shangjia_infos,
         'file_name': 'gycharm-sns-'+util_get_time(),
         'expire':get_expire()
     }

     return catalog_products;
}

function extract_shopify_export(){
    //
    var shangjia_infos = [];
    var q_name = $("textarea[name='q']").val();
    shangjia_infos.push({
        'url': q_name,
        'website':'',
        'domain': window.location.href,
        'title': '',
        'description':''
    })
    //
    var shangjia_infos_localStorage = [];
    if(localStorage.getItem("shangjia_infos_localStorage") == null){
        localStorage['shangjia_infos_localStorage'] = JSON.stringify([]);
    }
    shangjia_infos_localStorage = JSON.parse(localStorage['shangjia_infos_localStorage']);
    for(let f=0;f<shangjia_infos_localStorage.length;f++){
        shangjia_infos.push(shangjia_infos_localStorage[f]);
    }
    //
    search_localStorage_clean();
    //
    var catalog_products = {
        'shangjia_infos': shangjia_infos,
        'file_name': 'brand-sellers-'+util_get_time(),
        'expire':get_expire()
    }
    //
    return catalog_products;
}

//支持web、sns、shopify、videos (除了images、shopping)
function search_update_localStorage(){
    let current_url = window.location.href;
    let is_google_images = false;
    let is_google_shopping = false;
    let is_sns_search = false;
    //
    if(current_url){
        if(current_url.indexOf('tbm=isch') != -1){
            is_google_images = true;
        }else if(current_url.indexOf('tbm=shop') != -1){
            is_google_shopping = true;
        }
        //
        if(current_url.indexOf('facebook.com') != -1){
            is_sns_search = true;
        }else if(current_url.indexOf('twitter.com') != -1) {
            is_sns_search = true;
        }else if(current_url.indexOf('instagram.com') != -1){
            is_sns_search = true;
        }else if(current_url.indexOf('linkedin.com') != -1){
            is_sns_search = true;
        }else if(current_url.indexOf('youtube.com') != -1){
            is_sns_search = true;
        }else if(current_url.indexOf('pinterest.com') != -1){
            is_sns_search = true;
        }else if(current_url.indexOf('tiktok.com') != -1){
            is_sns_search = true;
        }else if(current_url.indexOf('reddit.com') != -1){
            is_sns_search = true;
        }else if(current_url.indexOf('vk.ru') != -1){
            is_sns_search = true;
        }else if(current_url.indexOf('vk.com') != -1){
            is_sns_search = true;
        }else if(current_url.indexOf('ok.ru') != -1){
            is_sns_search = true;
        }
        //
    }
    if(!is_google_images){
        console.log('search_update_localStorage ddd');
        console.log('b');
        var shangjia_infos_localStorage = [];
        if(localStorage.getItem("shangjia_infos_localStorage") == null){
            localStorage['shangjia_infos_localStorage'] = JSON.stringify([]);
        }
        shangjia_infos_localStorage = JSON.parse(localStorage['shangjia_infos_localStorage']);
        //
        if(!is_google_shopping && !is_sns_search){
            let tj = 0;
            $('#rcnt .MjjYud').each(function (){
                tj = tj +1 ;
                console.log('tj:'+tj);
                let a_href_val = $(this).find('a').attr('href');
                let a_domain_val  = util_url_get_domain(a_href_val);
                let shangjia_info_title = $(this).find('h3').text();
                let shangjia_info_desc = $(this).find('.VwiC3b').text();
                if(!shangjia_info_desc){
                    shangjia_info_desc = $(this).find('.mSA5Bd').text();
                }
                //video
                if(!shangjia_info_desc){
                    shangjia_info_desc = $(this).find('.ITZIwc').text();
                }
                //
                let is_exists = false;
                for(j=0;j<shangjia_infos_localStorage.length;j++){
                    if(shangjia_infos_localStorage[j]['domain'] == a_domain_val){
                        is_exists = true;
                        break;
                    }
                }
                //
                if(is_exists == false){
                    shangjia_infos_localStorage.push({
                        'url': a_href_val,
                        'website': util_getwebsite_url(a_href_val),
                        'domain': a_domain_val,
                        'title': shangjia_info_title,
                        'description': shangjia_info_desc
                    })
                }
                //
            });
            //
        }else if(is_google_shopping){
            let tj = 0;
            $('.sh-dgr__grid-result').each(function (){
                tj = tj +1 ;
                console.log('tj google shop:'+tj);
                let a_href_val = $(this).find('a.shntl').attr('href');
                if(a_href_val){
                    a_href_val = a_href_val.replace('/url?url=', '');
                    let a_domain_val  = util_url_get_domain(a_href_val);
                    let keyword_name = $(this).find('h3').text();
                    //
                    let is_exists = false;
                    for(j=0;j<shangjia_infos_localStorage.length;j++){
                        if(shangjia_infos_localStorage[j]['domain'] == a_domain_val){
                            is_exists = true;
                            break;
                        }
                    }
                    //
                    if(is_exists == false){
                        shangjia_infos_localStorage.push({
                            'url':a_href_val,
                            'website': util_getwebsite_url(a_href_val),
                            'domain': a_domain_val,
                            'title': keyword_name,
                            'description':'',
                        });
                    }
                    //
                }
            });
        }else if(is_sns_search){
            console.log('is_sns_search');
            let tj = 0;
            $('#rcnt .MjjYud').each(function (){
                tj = tj +1 ;
                console.log('tj:'+tj);
                let shangjia_info_desc = $(this).find('.VwiC3b').text();
                if(!shangjia_info_desc){
                    shangjia_info_desc = $(this).find('.mSA5Bd').text();
                }
                //video
                if(!shangjia_info_desc){
                    shangjia_info_desc = $(this).find('.ITZIwc').text();
                }
                if(!shangjia_info_desc){
                    shangjia_info_desc = $(this).find('.fzUZNc').text();
                }

                console.log('shangjia_info_desc');
                console.log(shangjia_info_desc);
                let shangjia_info_title = $(this).find('h3').text();
                //console.log('shangjia_info_title');
                //console.log(shangjia_info_title);
                let _extract_urls = util_extract_url(shangjia_info_desc);
                if(_extract_urls!=null){
                    for(let j=0;j<_extract_urls.length;j++){
                         let _website = _extract_urls[j];
                         let _domain  = util_url_get_domain(_website);
                         _website = _website.trim();
                         //
                         let is_exists = false;
                         for(j=0;j<shangjia_infos_localStorage.length;j++){
                            if(shangjia_infos_localStorage[j]['domain'] == _domain){
                                is_exists = true;
                                break;
                            }
                         }
                         if(!is_exists){
                             shangjia_infos_localStorage.push({
                                'url':_website,
                                'domain': _domain,
                                'title': shangjia_info_title,
                                'description':shangjia_info_desc,
                            })
                         }
                    }
                }
            });
        }
        //
        console.log('shangjia_infos_localStorage length:'+shangjia_infos_localStorage.length);
        //
        localStorage['shangjia_infos_localStorage'] = JSON.stringify(shangjia_infos_localStorage);
        //
    }
    //
    if(current_url.indexOf('search') !=-1 && !is_google_images){
        if(!is_google_shopping){
            let _tips = $("#_gycharm_tips");
            if(!_tips){
                $("#botstuff div[role='navigation']").append("<div id='_gycharm_tips' style='background-color: #cff4fc;color: #055160;width: 100px;text-align: center;padding:10px 0;margin:0 auto;margin-bottom:10px;margin-top:-15px;'>当前页已采集</div>");
            }
        }else if(is_google_shopping){
            let _tips = $("#_gycharm_tips");
            if(!_tips){
                $("div.huiPV #xjs").append("<div id='_gycharm_tips' style='background-color: #cff4fc;color: #055160;width: 100px;text-align: center;padding:10px 0;margin:0 auto;margin-bottom:10px;margin-top:-15px;'>当前页已采集</div>");
            }
        }
    }
    //
}

function search_localStorage_clean(){
    localStorage.removeItem("shangjia_infos_localStorage");
     //if(localStorage.getItem("tbm_map_urls") == null){
         localStorage['shangjia_infos_localStorage'] = JSON.stringify([]);
    // }
}

var navigation_url = '';
function perf_observer(list, obserer){
    //console.log('aa');
    //console.log(getNetworkRequests(list.getEntriesByType('resource')));
    performanceResourceList = list.getEntriesByType('resource');
    //console.log(performanceResourceList);
    for(i = 0; i<performanceResourceList.length; i++){
        performanceResourceItem = performanceResourceList[i];
        //console.log('abababa');
        //console.log(performanceResourceItem);
        if(performanceResourceItem['initiatorType'] == 'xmlhttprequest'){
            if(performanceResourceItem['name'].indexOf('search')!=-1){
                //console.log(performanceResourceItem['name']);
                console.log('bbbb'+performanceResourceItem['name']);
                //
                search_update_localStorage();
            }
        }
    }
}
var observer_ = new PerformanceObserver(perf_observer);
//observer_.observe({entryTypes:['resource', 'navigation']});
observer_.observe({entryTypes:['resource', 'navigation', 'paint']});
//

$(document).ready(function(){
  console.log('document on load');
  search_update_localStorage();
});


function set_expire(date=''){
    console.log('set_expire:'+date);
    var expire = [];
    if(localStorage.getItem("expire") == null){
        localStorage['expire'] = JSON.stringify([{'expire':''}]);
    }
    localStorage['expire'] = JSON.stringify([{'expire':date}]);

    expire = JSON.parse(localStorage['expire']);
    return expire;
}

function get_expire(){
    if(localStorage.getItem("expire") == null){
        localStorage['expire'] = JSON.stringify([{'expire':''}]);
    }
    expire = JSON.parse(localStorage['expire']);
    return expire;
}

// get popup2content info
chrome.runtime.onMessage.addListener((request, sender, sendResponse) => {
    if(request.action == 'extract_google_search_export'){
        catalog_products_url = extract_google_search_export();
        sendResponse(catalog_products_url);
    }else if(request.action == 'extract_sns_export'){
        catalog_products_url = extract_sns_export();
        sendResponse(catalog_products_url);
    }else if(request.action == 'extract_shopify_export'){
        catalog_products_url = extract_shopify_export();
        sendResponse(catalog_products_url);
    }else if(request.action == 'set_expire') {
        expire_date = set_expire(request.date);
        sendResponse(expire_date);
    }else if(request.action == 'get_expire'){
        expire_date = get_expire();
        sendResponse(expire_date);
    }
})
//

//send message to pop
function send_message_to_popup(message={}){
    /*
    {
            action: 'extract-catalog-products-export-clean',
            info: ''
        }
     */
    console.log('message');
    console.log(message);
    chrome.runtime.sendMessage(message,(msg)=>{
        console.log('答复',msg)
    })
}